<?php

namespace HCM\FPA\Calculos\Apolo;

require_once __DIR__.'/bootstrapConsumer.php';
error_reporting(E_ERROR | E_PARSE);
ini_set("memory_limit","2048M");

use Teknisa\Model\Gestaopessoas\Repositories\FpaCalculoconsumer;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;
use HCM\Util\FPA;
use HCM\Util\HCMParameters;
use HCM\FPA\Entity\FpatipocalculoEntity;
use HCM\Util\Mail\Mail;
use HCM\FPA\Calculos\Apolo\PercorreCalculoConsumer;
use Zeedhi\Framework\Session\Session;
use Teknisa\Libs\Util\SMTP;

class MigracaoConsumer extends \Zeedhi\Queue\Consumer {

    const QUEUE_NAME_MIGRACAO = "hcm_migracaoFichaFinanceira_";

	protected static $queueName = '/queue/';
	
    public $fpaCalculoConsumer;
    
    private $nrcalculoconsumer;
    private $dsemailoper;
    private $cdoperador;
    private $dtmescompetencia;
    private $nrorg;
    private $tp_processamento;
    private $tipo_calculo;
    private $nrFormulario;
    private $pid;
    private $corpoEmail;
    private $mensagens = array();
    
    public function setQueueName($queueName, $pid) {
        self::$queueName .= $queueName;
        $this->pid = $pid;
    }
    
	/**
     * @param string $message
     * @return void
     */
    public function consume($message) {        
        // Tempo de execucao deve ser ilimitado.
        set_time_limit(0);
        error_reporting(E_ERROR | E_PARSE);
            
        $session = new Session();
        $this->hcmParameters = new HCMParameters($session, FPA::getTempDirectory(), null, null);
        
        $this->entityManager = \Setforms2\Shared\Registry::getEntityManager();
            
    	try {
            echo ">>>>>>>>>> Iniciando Processo <<<<<<<<<<".PHP_EOL;
            echo 'Pid = '.$this->pid.PHP_EOL;
            
            $consumerParams = json_decode($message, true);
            
            $importacaoItensParams  = $consumerParams['IMPORTACAO_PARAMS'][0];
            $dataset = $importacaoItensParams['DATASET'];
            
            $this->setParameters($importacaoItensParams);
            
            $nrorg = $this->hcmParameters->getNrorgTrabalho();
            $nrlotelancevento = $importacaoItensParams['NRLOTELANCEVENTO'];
            
            $this->entityManager->beginTransaction();
            
            $lote = $this->entityManager->getRepository(Repositories::FPA_LOTELANCEVENTO)->findOneBy(array('nrorg' => $nrorg, 'nrlotelancevento' => $nrlotelancevento));
            $itensLote = $this->entityManager->getRepository(Repositories::FPA_ITEMLOTELANC)->findBy(array('nrorg' => $nrorg, 'nrlotelancevento' => $lote->getNrlotelancevento()));
            
            $nritens = 0;
            
            foreach($dataset as $row){
                $nreventom = $this->getEventoDePara($row['NREVENTOM']);
                if (!$nreventom) {
                    $this->mensagens[] = "Não encontrada parametrização De/Para do evento " . $row['NREVENTOM'];
                } else {
                    $novoItem = $this->novoItemLoteFicha($nrorg, $row['NRVINCULOM'], $nreventom, $row['VREVENTOFOLHA'], $row['DTOCORRENCIA'], $lote->getNrlotelancevento(), $row['VRREFFOLHA'], 'S', $row['DSCALCULO']);
                    $nritens++;
                }
            }
             
            /*if ($lote->getIdstatuslotelanc() == 'DIGITACAO' && count($itensLote) == $lote->getQtdeitenstotal()){
                $lote->setIdstatuslotelanc('PENDENTE');
            }*/
    
            // Define parametros do operador.
            $ambiente = $this->showAmbiente($nrlotelancevento);
            
            // set a propriedade DSOBSLOTELANC do registro em lotelacevento
            $lote->setDsobslotelanc(str_replace("\n", " - ", $ambiente));
            $lote->setIdstatuslotelanc('PENDENTE');
            $this->entityManager->persist($lote);
            $this->entityManager->flush();
            
            $this->entityManager->commit();
            //Envia email para o operador informando o término do calculo.
            $this->notificaMigracao($ambiente, $nritens);
            $pid = explode(',', $calculoConsumer[0]['DSPIDPROCESSO']);
            return array(true, $this->pid, array_unique($pid));
            
        } catch (\Exception $e) {
            $this->entityManager->rollback();
            echo "Erro: ".$e->getMessage();
            $this->kill($this->pid);
            die();
        }
    }
    
    public function getEventoDePara($nrEventoDe) {
        $migramdepara = $this->entityManager->getRepository(Repositories::MIGRAMDEPARA)->findOneBy(array('nrorg' => $this->hcmParameters->getNrorgTrabalho(), 'nrde' => $nrEventoDe));
        return is_object($migramdepara) ? $migramdepara->getNrpara() : false;
    }
    
    public function novoItemLoteFicha($nrorg, $nrvinculom, $nreventom, $vreventolote, $dtocorrencia, $nrlotelancevento, $vrreffolhalote, $idativo = 'S', $dsobservacao = null){
        $fpa_itemlotelanc = Repositories::FPA_ITEMLOTELANC;
        
        $item = $this->entityManager->getRepository(Repositories::FPA_ITEMLOTELANC)->findOneBy(
            array('nrorg' => $nrorg, 'nrlotelancevento' => $nrlotelancevento, 'nrvinculom' => $nrvinculom, 'nreventom' => $nreventom)
        );
        if (is_object($item)) {
            $this->mensagens[] = "Evento $nreventom já importado para o vínculo $nrvinculom";
        } else {
            $item = new $fpa_itemlotelanc;
            
            $item->setNrorg($nrorg);
            $item->setNreventom($nreventom);
            $item->setNrvinculom($nrvinculom);
            $item->setNrlotelancevento($nrlotelancevento);
            $item->setIdativo($idativo);
            $item->setDsobservacao($dsobservacao);
            $item->setDtocorrencia(DateUtil::getDataDeString($dtocorrencia, DateUtil::FORMATO_BRASILEIRO, true));
            $item->setVreventolote($vreventolote);
            $item->setVrreffolhalote($vrreffolhalote);
            
            $item->setDtinclusao(DateUtil::getDataAtual());
            $item->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
            $item->setCdoperinclusao($this->hcmParameters->getCdoperador());
            $item->setDtultatu(DateUtil::getDataAtual());
            $item->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
            $item->setCdoperultatu($this->hcmParameters->getCdoperador());
            
            $item->setNritlotelanc(\HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'FPA_ITEMLOTELANC', 1, 12, true));
        }
        
        $this->entityManager->persist($item);
        $this->entityManager->flush();
        return $item; 
    }
    
    public function notificaMigracao($ambiente, $nritens){
        $cdoperador = FPA::getCdOperador();
        $operador = self::retornaOperadorLogado($cdoperador);

        $emailOperadorLogado = $operador->getDsemailoper();
        $nomeOperadorLogado = $operador->getNmoperador();
        $nome_destinatario = $nomeOperadorLogado;
        
        $assunto = "Migração da Ficha Financeira - Importação Lote";
        
        $corpo_msg = 
            $nomeOperadorLogado.
            "<br> ".$ambiente." <br>".
            "<br> Importação de ".$nritens." itens finalizada.".
            implode("<br> ",$this->mensagens);
        
        $mail = $this->hcmParameters->returnParamsSmtp(true);
 
        if(!$mail){
            return;
        }
        
        try {
            $return = $mail->newEmail(
                $emailOperadorLogado,  //De/From
                $corpo_msg,            //texto
                $assunto,              //assunto    
                $nomeOperadorLogado,   //nome operador
                $nomeOperadorLogado,   //nome from
                $emailOperadorLogado   //from
            );
            if($return === false){
                echo "Erro ao enviar email <br>";
            }
        }catch (Exception $e) {
            $contFail++;
        }
    }

    public function retornaOperadorLogado($cdoperador){
        $operador = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::OPERADOR)->findOneBy(array('cdoperador' => $cdoperador));
        return $operador;
    }

    private function setParameters($consumerParams) {
        
        $this->dataSet           = $consumerParams["DATASET"];
        $this->dsemailoper       = $consumerParams["DSEMAILOPER"];
        $this->cdoperador        = $consumerParams["CDOPERADOR"];
        $this->dtmescompetencia  = $consumerParams["DTMESCOMPETENCIA"];
        $this->nrorg             = $consumerParams["NRORG"];
        
        foreach ($consumerParams["PARAMSHCM"] as $key => $value) {
            $this->hcmParameters->set($key, $value);
        }
    }

    private function showAmbiente($nrlotelancevento) {
        $dataExecucao       = DateUtil::getDataAtual();

        $ambiente = "Org.: $this->nrorg\n Competencia: $this->dtmescompetencia\n Lote Ficha Financeira: $nrlotelancevento\n Operador: $this->cdoperador\n Data Execucao: $dataExecucao";
        
        echo $ambiente."<br>";
        echo "<br>"."---------------"."<br>";
        
        return $ambiente;
    }
}

if (!isset($argv[1])) {
    die('Parametro de organizacao nao informado.');
}

$nrorg = $argv[1];
$pid = getmypid();

$paramsApolo = FPA::getParamsApolo();
        
$url = $paramsApolo['URL'];
$port = $paramsApolo['PORT'];
$user = $paramsApolo['USER'];
$password = $paramsApolo['PASSWORD'];
$broke = $paramsApolo['BROKE'];

$connection = new \Zeedhi\Queue\Connection($url, $port, $user, $password, $broke);

$consumer = new MigracaoConsumer($connection);
$consumer->setQueueName(MigracaoConsumer::QUEUE_NAME_MIGRACAO.$nrorg, $pid);
$consumer->run();