<?php
namespace HCM\FPA\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\DateUtil;

class MonitCalcRepository {

    protected  $connection;
    
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
        
    }
    
    public function getMensagensMonit($filters, $params){
        $conditions = "";
        
        foreach ($filters as $filter) {
            if($filter["columnName"] == "NRCALCULOFOLHA"){
                $conditions .= " AND MSGC.".$filter["columnName"]." LIKE ("."'".$filter["value"]."'".")";
            }else if($filter["columnName"] == "NRCALCULOCONSUMER"){
                $conditions .= " AND MSGC.".$filter["columnName"]." LIKE ("."'".$filter["value"]."'".")";
            }
        }
        
        $query = "SELECT * FROM FPA_MSGCALCULO MSGC JOIN GPE_VINCULOM VM ON VM.NRORG = :P_NRORG AND VM.NRVINCULOM = MSGC.NRVINCULOM WHERE MSGC.NRORG = :P_NRORG
		".$conditions;
		
		
        $sql = $this->entityManager->getConnection()->prepare($query);
        $sql->execute($params);
        
        return $sql->fetchAll();
    }
    
    public function getMonitCalc($filters, $params){
        
        $conditions = "";
        
        foreach ($filters as $filter) {
            if($filter["columnName"] != "NRORG"){
                if($filter["columnName"] == "DTHRINICIO"){
                    $conditions .= " AND A.DTHRINICIO BETWEEN :inicio AND :fim ";
                    $params["inicio"] = DateUtil::getDataDeString($filter["value"])->format('d/m/Y');
                    $params["fim"] = DateUtil::adicionaIntervalo(DateUtil::getUltimoDiaDoMes(DateUtil::getDataDeString($filter["value"])), 1)->format('d/m/Y');
                }else if($filter["columnName"] == "NRCALCULOFOLHA"){
                    $conditions .= " AND A.".$filter["columnName"]." LIKE ("."'".$filter["value"]."'".")";
                }else if($filter["columnName"] == "DSORDEM"){
                    $conditions .= " AND A.".$filter["columnName"]." LIKE ("."'".$filter["value"]."'".")";
                } else if($filter["columnName"] == "DSINICIO"){
                    $conditions .= " AND A.".$filter["columnName"]." LIKE ("."'".$filter["value"]."'".")";
                } else if($filter["columnName"] == "DSFIM"){
                    $conditions .= " AND A.".$filter["columnName"]." LIKE ("."'".$filter["value"]."'".")";
                }
                else{
                    $conditions .= " AND A.".$filter["columnName"]." ".$filter["operator"]." ".$filter["value"];
                }
            }
        }
		$query = "
		SELECT * FROM(
    		SELECT 
                DECODE(NVL(CC.DSPIDPROCESSO,'X'), 'X', 'N', 'S') AS IDLOTE ,
                --Tempo Executando
                DECODE(CC.IDSITUACAO, 'ANDAMENTO', TO_CHAR(TRUNC(((SYSDATE - CC.DTHRINICIO) * 86400)/3600),'FM9900')
                || ':' || TO_CHAR(TRUNC(MOD(((SYSDATE - CC.DTHRINICIO) * 86400),3600)/60),'FM00')
                || ':' || TO_CHAR(MOD(((SYSDATE - CC.DTHRINICIO) * 86400),60),'FM00'), 
                --Tempo Total
                (TO_CHAR(TRUNC(((CC.DTHRFIM - CC.DTHRINICIO) * 86400)/3600),'FM9900') 
                || ':' || TO_CHAR(TRUNC(MOD(((CC.DTHRFIM - CC.DTHRINICIO) * 86400),3600)/60),'FM00') 
                || ':' || TO_CHAR(MOD(((CC.DTHRFIM - CC.DTHRINICIO) * 86400),60),'FM00'))
                ) AS DTHREXEC,    
                -- Tempo estimado
                DECODE(CC.IDSITUACAO, 'ANDAMENTO', TO_CHAR(TRUNC(((((SYSDATE - CC.DTHRINICIO) * 86400 / CC.NRTOTPROCESSVINC) * (CC.NRTOTVINCULOS - CC.NRTOTPROCESSVINC))/3600)),'FM9900')
                || ':' || TO_CHAR(TRUNC(MOD((((SYSDATE - CC.DTHRINICIO) * 86400 / CC.NRTOTPROCESSVINC) * (CC.NRTOTVINCULOS - CC.NRTOTPROCESSVINC)),3600)/60),'FM00')
                || ':' || TO_CHAR(MOD((((SYSDATE - CC.DTHRINICIO) * 86400 / CC.NRTOTPROCESSVINC) * (CC.NRTOTVINCULOS - CC.NRTOTPROCESSVINC)),60),'FM00'), NULL) AS DTHRESTIMADO,    
                -- Porcentagem do calculo
                ROUND((CC.NRTOTPROCESSVINC / CC.NRTOTVINCULOS) * 100) || '%' AS PERCENTCON,    
                CC.*,
                TM.NRTIPOMOVIMENT,
                TM.NMTIPOMOVIMENT,
                CASE CC.DSORDEM
                    WHEN 'LISTA_VINCULO' THEN 
                    (SELECT LISTAGG(SUBSTR(NMVINCULOM, 1, 30), ', ') WITHIN GROUP (ORDER BY NRVINCULOM) 
                    FROM GPE_VINCULOM 
                        WHERE NRORG = CC.NRORG 
                        AND INSTR(','||CC.DSINICIO||',', ','||NRVINCULOM||',') > 0
                        AND ROWNUM <= 125)
                    WHEN 'LISTA_BENEFICIO' THEN 
                    (SELECT LISTAGG(SUBSTR(DSBENEFICIO, 1, 50), ', ') WITHIN GROUP (ORDER BY NRBENEFICIOM) 
                    FROM VAB_BENEFICIOH 
                        WHERE NRORG = CC.NRORG
                        AND DTMESCOMPETENC = (SELECT * FROM (SELECT DTMESCOMPETENC FROM VAB_BENEFICIOH WHERE DTMESCOMPETENC <= TRUNC(CC.DTHRINICIO, 'MM') AND NRORG = CC.NRORG AND INSTR(','||CC.DSINICIO||',', ','||NRBENEFICIOM||',') > 0 ORDER BY DTMESCOMPETENC DESC)WHERE ROWNUM = 1)
                        AND INSTR(','||CC.DSINICIO||',', ','||NRBENEFICIOM||',') > 0
                        AND ROWNUM <= 125)
                    WHEN 'ESTRUTURA' THEN 
                    (SELECT LISTAGG(SUBSTR(NMESTRUTURAM, 1, 50), ', ') WITHIN GROUP (ORDER BY NRESTRUTURAM) 
                    FROM ESTRUTURAM 
                        WHERE NRORG = CC.NRORG 
                        AND INSTR(','||CC.DSINICIO||',', ','||NRESTRUTURAM||',') > 0
                        AND ROWNUM <= 76)
                    WHEN 'LISTA_ESTRUTURA' THEN 
                    (SELECT LISTAGG(SUBSTR(NMESTRUTURAM, 1, 50), ', ') WITHIN GROUP (ORDER BY NRESTRUTURAM) 
                    FROM ESTRUTURAM 
                        WHERE NRORG = CC.NRORG 
                        AND INSTR(','||CC.DSINICIO||',', ','||NRESTRUTURAM||',') > 0
                        AND ROWNUM <= 76)
                    WHEN 'LISTA_HIERARQUIA' THEN 
                    (SELECT LISTAGG(SUBSTR(NMTIPOHIERARQORG, 1, 50), ', ') WITHIN GROUP (ORDER BY NRTIPOHIERARQORG) 
                    FROM TIPOHIERARQORG 
                        WHERE NRORG = CC.NRORG 
                        AND INSTR(','||CC.DSINICIO||',', ','||NRTIPOHIERARQORG||',') > 0
                        AND ROWNUM <= 76)
                    WHEN 'LISTA_LOTE' THEN 
                    (SELECT LISTAGG(SUBSTR(NMLOTEVINC, 1, 30), ', ') WITHIN GROUP (ORDER BY NRLOTEVINC) 
                    FROM FPA_LOTEVINC 
                        WHERE NRORG = CC.NRORG 
                        AND INSTR(','||CC.DSINICIO||',', ','||NRLOTEVINC||',') > 0
                        AND ROWNUM <= 125)
                    WHEN 'LISTA_TOMADOR' THEN 
                    (SELECT LISTAGG(SUBSTR(NMESTRUTURAM, 1, 50), ', ') WITHIN GROUP (ORDER BY NRESTRUTURAM) 
                    FROM ESTRUTURAM 
                        WHERE NRORG = CC.NRORG 
                        AND INSTR(','||CC.DSINICIO||',', ','||NRESTRUTURAM||',') > 0
                        AND ROWNUM <= 76)
                END AS NMINICIO,
                CASE CC.DSORDEM
                    WHEN 'ESTRUTURA' THEN 
                    (SELECT LISTAGG(SUBSTR(NMESTRUTURAM, 1, 50), ', ') WITHIN GROUP (ORDER BY NRESTRUTURAM) 
                    FROM ESTRUTURAM 
                        WHERE NRORG = CC.NRORG 
                        AND INSTR(','||CC.DSFIM||',', ','||NRESTRUTURAM||',') > 0
                        AND ROWNUM <= 76)
                    WHEN 'LISTA_ESTRUTURA' THEN 
                    (SELECT LISTAGG(SUBSTR(NMESTRUTURAM, 1, 50), ', ') WITHIN GROUP (ORDER BY NRESTRUTURAM) 
                    FROM ESTRUTURAM 
                        WHERE NRORG = CC.NRORG 
                        AND INSTR(','||CC.DSFIM||',', ','||NRESTRUTURAM||',') > 0
                        AND ROWNUM <= 76)
                    WHEN 'LISTA_TOMADOR' THEN 
                    (SELECT LISTAGG(SUBSTR(NMESTRUTURAM, 1, 50), ', ') WITHIN GROUP (ORDER BY NRESTRUTURAM) 
                    FROM ESTRUTURAM 
                        WHERE NRORG = CC.NRORG 
                        AND INSTR(','||CC.DSFIM||',', ','||NRESTRUTURAM||',') > 0
                        AND ROWNUM <= 76)
                    WHEN 'LISTA_HIERARQUIA' THEN 
                    (SELECT LISTAGG(SUBSTR(NMESTRUTURAM, 1, 50), ', ') WITHIN GROUP (ORDER BY NRESTRUTURAM) 
                    FROM ESTRUTURAM 
                        WHERE NRORG = CC.NRORG 
                        AND INSTR(','||CC.DSFIM||',', ','||NRESTRUTURAM||',') > 0
                        AND ROWNUM <= 76)
                END AS NMFIM
            FROM FPA_CALCULOCONSUMER CC 
    		LEFT JOIN FPA_CALCULOFOLHA CF ON CC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA AND(CF.NRORG = :P_NRORG OR CF.NRORG = :P_NRORG_PADRAO) 
    		LEFT JOIN FPA_TIPOMOVIMENT TM ON CF.NRTIPOMOVIMENT = TM.NRTIPOMOVIMENT AND (TM.NRORG = :P_NRORG OR TM.NRORG = :P_NRORG_PADRAO) 
		) A WHERE (A.NRORG = :P_NRORG OR A.NRORG = :P_NRORG_PADRAO)
		
		".$conditions." ORDER BY A.DTHRINICIO DESC";
		
        $sql = $this->entityManager->getConnection()->prepare($query);
        $sql->execute($params);
        return $sql->fetchAll();
    }
} 
