<?php

namespace HCM\SST\Controllers;

use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use HCM\Util\HCMParameters;

class IndicadoresSegurancaTrabalhoController extends Crud {

    protected $parameterBagColumns = array('P_NRORG', 'P_NRORG_PADRAO', 'P_DTMESCOMPETENC', 'P_NRESTRUTLEGAL', 'P_NRESTRUTGEREN', 'P_NRESTRUTSIND', 'P_NRESTRUTTOMAD', 'P_NRTIPOESTRUTGEREN', 'P_NRTIPOESTRUTOMADOR');
    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, HCMParameters $hcmParameters){
        $this->parameterBag = $parameterBag;
        $this->hcmParameters = $hcmParameters;
        parent::__construct($dataSourceManager);
    }

    public function getTotalEPIsEntreguesLegalOcupacao(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_totalEPIsEntreguesLegalOcupacao_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getTotalEPIsEntreguesGerenOcup(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_totalEPIsEntreguesGerenOcup_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getTotalEPIsEntreguesTomadorOcup(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_totalEPIsEntreguesTomadorOcup_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }
    
    public function getTotalEPIsEntreguesOcupacaoGeral(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_totalEPIsEntreguesOcupGeral_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getTotalEPIsEntreguesVencidosLegalOcupacao(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_totalEpisEntregues_vencidos_legalOcup_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getTotalEPIsEntreguesVencidosGerenOcup(DTO\Request\Filter $request, DTO\Response $response)
    {  
        $this->dataSourceName = "sst_totalEpisEntregues_vencidos_gerenOcup_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getTotalEPIsEntreguesVencidosTomadorOcup(DTO\Request\Filter $request, DTO\Response $response)
    {  
        $this->dataSourceName = "sst_totalEPIsEntregues_vencidos_TomadorOcup_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }
    
    public function getTotalEPIsEntreguesVencidosOcupacaoGeral(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_totalEpisEntregues_vencidos_ocupGeral_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getTotalEPIsEntreguesCAVencidoLegalOcupacao(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_totalEpisEntregues_caVencido_legalOcup_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getTotalEPIsEntreguesCAVencidoGerenOcup(DTO\Request\Filter $request, DTO\Response $response)
    {  
        $this->dataSourceName = "sst_totalEpisEntregues_caVencido_gerenOcup_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getTotalEPIsEntreguesCAVencidosTomadorOcup(DTO\Request\Filter $request, DTO\Response $response)
    {  
        $this->dataSourceName = "sst_totalEPIsEntregues_caVencido_TomadorOcup_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }
    
    public function getTotalEPIsEntreguesCAVencidoOcupacaoGeral(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_totalEpisEntregues_caVencido_ocupGeral_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getTotalAcidentesLegalOcupacao(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_totalAcidentesLegalOcupacao_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getTotalAcidentesGerenOcup(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_totalAcidentesGerenOcup_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getTotalAcidentesTomadorOcup(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_totalAcidentesTomadorOcup_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }
    
    public function getTotalAcidentesOcupacaoGeral(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_totalAcidentesOcupGeral_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getTotalAcidentesPorGravidadeLegalOcupacao(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_totalAcidentesPorGravidadeLegalOcupacao_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getTotalAcidentesPorGravidadeGerenOcup(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_totalAcidentesPorGravidadeGerenOcup_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getTotalAcidentesPorGravidadeTomadorOcup(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_totalAcidentesPorGravidadeTomadorOcup_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }
    
    public function getTotalAcidentesPorGravidadeOcupacaoGeral(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_totalAcidentesPorGravidadeOcupGeral_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getQuantidadeDiasAfastadosLegalOcup(DTO\Request\Filter $request, DTO\Response $response)
    {   

        $this->dataSourceName = "sst_quantidadeDiasAfastadosLegalOcupacao_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getQuantidadeDiasAfastadosOcupacaoGeral(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_quantidadeDiasAfastadosOcupGeral_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getTotalPartesDoCorpoAtingidasLegalOcup(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_totalPartesDoCorpoAtingidasLegalOcupacao_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getTotalPartesDoCorpoAtingidasOcupacaoGeral(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_totalPartesDoCorpoAtingidasOcupGeral_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getSituacaoGeradoraAcidenteLegalOcup(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_situacaoGeradoraAcidenteLegalOcupacao_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getSituacaoGeradoraAcidenteOcupacaoGeral(DTO\Request\Filter $request, DTO\Response $response)
    {  
        $this->dataSourceName = "sst_situacaoGeradoraAcidenteOcupGeral_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }


    public function getReuniaoPorMes(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_reuniaoPorMes_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getReuniaoPorAno(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_reuniaoPorAno_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function getTotalReuniaoPorTipoReuniao(DTO\Request\Filter $request, DTO\Response $response)
    {   
        $this->dataSourceName = "sst_totalReuniaoPorTipoReuniao_get";
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        self::adicionaCondicoes($filterData);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }
    

    protected function processConditionValue($condition)
    {
        return $condition['value'];
    }

    protected function populateParameterBag(FilterCriteria $filterCriteria)
    {

        $conditions = array();
        foreach ($filterCriteria->getConditions() as $condition) {
            $columnName = $condition['columnName'];
            if (in_array($columnName, $this->parameterBagColumns)) {
                $this->parameterBag->set($columnName, $this->processConditionValue($condition));
            } else {
                $conditions[] = $condition;
            }
        }
        $newFilterCriteria = new FilterCriteria(
            $filterCriteria->getDataSourceName(),
            $conditions,
            $filterCriteria->getPage(),
            $filterCriteria->getPageSize()
        );
        return $newFilterCriteria;
    }

    private function adicionaCondicoes($filterData)
    {   
        $filterData->addCondition('P_NRTIPOESTRUTGEREN', '=', $this->hcmParameters->getTipoEstruturaGerencialOrg());
        $filterData->addCondition('P_NRTIPOESTRUTOMADOR', '=', $this->hcmParameters->getTipoEstruturaTomadorOrg());
        return $filterData;
    }
} 