<?php

namespace HCM\SST\Repository;

use Doctrine\ORM\EntityManager;
use HCM\Util\Util;

class RelatCustomFuncExamVencidosRepository {

    protected  $connection;
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
 /**
     * @return array
     */

    public function getRelatCustomExamVencidos($parameters) {
        $sql = "    
SELECT
    VM.NRVINCULOM,
    VM.NMVINCULOM,
    EM.NMESTRUTURAM,
    EM.NRESTRUTURAM NRESTRUTLEGAL,
    EG.NMESTRUTURAM NMESTRUTGEREN,
    EG.NRESTRUTURAM NRESTRUTGEREN,
    EXM.NMEXAME,
    EXF.DTVENCIMENTOEXAME,
    EXF.DTREALIZACAOEXAME
FROM
    GPE_VINCULOM VM
JOIN
    GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                    AND VH.NRVINCULOM = VM.NRVINCULOM
                    AND VH.DTMESCOMPETENC = (
        SELECT
            DTMESCOMPETENC
        FROM
            (
                SELECT
                    DTMESCOMPETENC
                FROM
                    GPE_VINCULOH
                WHERE
                        DTMESCOMPETENC <= :P_DTMESCOMPETENC
                    AND NRORG = VH.NRORG
                    AND NRVINCULOM = VH.NRVINCULOM
                ORDER BY
                    DTMESCOMPETENC DESC
            )
        WHERE
            ROWNUM = 1
    )
LEFT JOIN
    ESTRUTURAM EM ON EM.NRORG = VM.NRORG
                  AND EM.NRESTRUTURAM = VH.NRESTRUTLEGAL
LEFT JOIN
    ESTRUTURAH EH ON EH.NRESTRUTURAM = EM.NRESTRUTURAM
                  AND EH.NRORG = EM.NRORG
                  AND EH.DTMESCOMPETENC = (
        SELECT
            DTMESCOMPETENC
        FROM
            (
                SELECT
                    DTMESCOMPETENC
                FROM
                    ESTRUTURAH
                WHERE
                        DTMESCOMPETENC <= :P_DTMESCOMPETENC
                    AND NRORG = EH.NRORG
                    AND NRESTRUTURAM = EH.NRESTRUTURAM
                ORDER BY
                    DTMESCOMPETENC DESC
            )
        WHERE
            ROWNUM = 1
    )
LEFT JOIN
    ESTRUTURAM EG ON EG.NRORG = VM.NRORG
                  AND EG.NRESTRUTURAM = VH.NRESTRUTGEREN
LEFT JOIN
    ESTRUTURAH EGH ON EGH.NRESTRUTURAM = EG.NRESTRUTURAM
                   AND EGH.NRORG = EG.NRORG
                   AND EGH.DTMESCOMPETENC = (
        SELECT
            DTMESCOMPETENC
        FROM
            (
                SELECT
                    DTMESCOMPETENC
                FROM
                    ESTRUTURAH
                WHERE
                        DTMESCOMPETENC <= :P_DTMESCOMPETENC
                    AND NRORG = EH.NRORG
                    AND NRESTRUTURAM = EGH.NRESTRUTURAM
                ORDER BY
                    DTMESCOMPETENC DESC
            )
        WHERE
            ROWNUM = 1
    ) /*Estrutura superior*/
LEFT JOIN
    HIERARQUIAORG HO ON HO.NRORG = VM.NRORG
                     AND HO.NRTIPOHIERARQORG = :P_NRTIPOHIERARQORG
                     AND HO.NRESTRUTURAMREL = VH.NRESTRUTGEREN
                     AND HO.DTINIVIGENCIA = (
        SELECT
            DTINIVIGENCIA
        FROM
            (
                SELECT
                    DTINIVIGENCIA
                FROM
                    HIERARQUIAORG
                WHERE
                        NRORG = HO.NRORG
                    AND NRTIPOHIERARQORG = HO.NRTIPOHIERARQORG
                    AND NRESTRUTURAMREL = HO.NRESTRUTURAMREL
                    AND DTINIVIGENCIA <= :P_DTMESCOMPETENC
                ORDER BY
                    DTINIVIGENCIA DESC
            )
        WHERE
            ROWNUM = 1
    )
LEFT JOIN
    ESTRUTURAH EHS ON EHS.NRORG = VM.NRORG
                   AND EHS.NRESTRUTURAM = HO.NRESTRUTURAMSUP
                   AND EHS.DTMESCOMPETENC = (
        SELECT
            DTMESCOMPETENC
        FROM
            (
                SELECT
                    DTMESCOMPETENC
                FROM
                    ESTRUTURAH
                WHERE
                        NRORG = EHS.NRORG
                    AND NRESTRUTURAM = EHS.NRESTRUTURAM
                    AND DTMESCOMPETENC <= :P_DTMESCOMPETENC
                ORDER BY
                    DTMESCOMPETENC DESC
            )
        WHERE
            ROWNUM = 1
    )
JOIN
    SST_FICHAMEDICA SSFM ON SSFM.NRORG = VM.NRORG
                         AND SSFM.NRVINCULOM = VM.NRVINCULOM
JOIN
    SST_EXAMEFICHAMED EXF ON EXF.NRORG = VM.NRORG
                           AND EXF.NRFICHAMEDICA = SSFM.NRFICHAMEDICA
JOIN
    SST_EXAME EXM ON EXM.NRORG = VM.NRORG
                  AND EXM.NREXAME = EXF.NREXAME
WHERE
        VM.NRORG = :P_NRORG
    AND EXF.DTVENCIMENTOEXAME IS NOT NULL
    AND (INSTR(',' || :P_NRVINCULOM    || ',', ',' || VM.NRVINCULOM       || ',') >0 OR  :P_NRVINCULOM        IS NULL)
    AND (INSTR(',' || :P_NRESTRUTLEGAL || ',', ',' || VH.NRESTRUTLEGAL    || ',') > 0 OR :P_NRESTRUTLEGAL     IS NULL)
    AND (INSTR(',' || :P_NRESTRUTGEREN || ',', ',' || VH.NRESTRUTGEREN    || ',') > 0 OR :P_NRESTRUTGEREN     IS NULL)
    AND (INSTR(',' || :P_NRESTRUTSUPERIOR || ',', ',' || EHS.NRESTRUTURAM || ',') > 0 OR :P_NRESTRUTSUPERIOR  IS NULL)
    AND (EXF.DTVENCIMENTOEXAME >= :P_DTINICIO OR :P_DTINICIO IS NULL)
    AND (EXF.DTVENCIMENTOEXAME <= :P_DTFINAL  OR :P_DTFINAL  IS NULL)
    ";
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        
        $query->execute($parameters);
        
        return $query->fetchAll();
    }
}
        
 

