<?php

namespace HCM\SST\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\DateUtil;
use HCM\Util\Repositories;
use HCM\SST\Repository\InstrumentosAvalRiscosRepository;

class InstrumentosAvalRiscosService {
    
    protected $entityManager;
    protected $hcmParameters;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters, InstrumentosAvalRiscosRepository $instrumentosAvalRiscosRepository) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->instrumentosAvalRiscosRepository = $instrumentosAvalRiscosRepository;
    }

    public function existeMarca($row)
    {      
        return $this->instrumentosAvalRiscosRepository->existeMarca($row);
    }

    public function existeItensFilhos($nrorg, $nrinstrumento) 
    {
        return $this->instrumentosAvalRiscosRepository->existeItensFilhos($nrorg, $nrinstrumento);
    }
    
    public function existeInstrumento($nrorg, $nminstrumento) 
    {
        return $this->instrumentosAvalRiscosRepository->existeInstrumento($nrorg, $nminstrumento);
    } 

    public function existeMarcaInstrumento($nrorg, $nrmarca, $nrinstrumento) 
    {
        return $this->instrumentosAvalRiscosRepository->existeMarcaInstrumento($nrorg, $nrmarca, $nrinstrumento);
    } 
}