<?php

namespace HCM\VAB\IntegracaoVT;


class LeitorFetranspor extends Leitor
{
    protected $formatosAceitos = 'XLSX|XLSM|XLTX|XLTM|XLS|XLT|ODS|OTS|SLK|XML';

    protected function abrirArquivo( $caminho)
    {
        $info = \PHPExcel_IOFactory::load($caminho);
        $info->setActiveSheetIndex(0);

        return $info;
    }


    protected function preparaInfo( $info)
    {
        $idLinha = 7;
        $idColCartao = 'A';
        $idColNome = 'C';
        $idColMatricula = 'G';
        $idColSaldo = 'R';

        $infoFinal = array();
        $numCartaoFloat = $info->getActiveSheet()->getCell($idColCartao.$idLinha)->getValue();
        $numCartao = self::formattedToString($numCartaoFloat, $idColCartao.$idLinha, $info);
        $saldo = $info->getActiveSheet()->getCell($idColSaldo.$idLinha)->getValue();
        $matriculaFloat = $info->getActiveSheet()->getCell($idColMatricula.$idLinha)->getValue();
        $matricula = self::formattedToString($matriculaFloat, $idColMatricula.$idLinha, $info);
        $nome = $info->getActiveSheet()->getCell($idColNome.$idLinha)->getValue();
        $idLinha++;
        while(!empty($numCartao)){
            $reg = array();
            $reg['NUMERO_CARTAO'] =  $numCartao;
            $reg['SALDO_CARTAO'] = $saldo;
            $reg['MATRICULA'] = $matricula;
            $reg['NOME'] = $nome;
            
            $numCartaoFloat = $info->getActiveSheet()->getCell($idColCartao.$idLinha)->getValue();
            $numCartao = self::formattedToString($numCartaoFloat, $idColCartao.$idLinha, $info);
            $saldo = $info->getActiveSheet()->getCell($idColSaldo.$idLinha)->getValue();
            $matriculaFloat = $info->getActiveSheet()->getCell($idColMatricula.$idLinha)->getValue();
            $matricula = self::formattedToString($matriculaFloat, $idColMatricula.$idLinha, $info);
            $nome = $info->getActiveSheet()->getCell($idColNome.$idLinha)->getValue();
            $idLinha++;
            $infoFinal[] = $reg;
        }
        return $infoFinal;
    } 

    private static function formattedToString($float, $col, $info)
    {   
        $info->getActiveSheet()->setCellValueExplicit($col, $float, \PHPExcel_Cell_DataType::TYPE_STRING);
        $formatted = $info->getActiveSheet()->getCell($col)->getFormattedValue();
        return $formatted;
    }
}