-- ============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 12.x 
--   Created on:     11/08/2023  12:00                        
--   Issue:          438767 -  [HCM] - Erro PK - Tabela VAB_HISTVALEVINC

-- ============================================================
-- Table: NOVOCODIGO
-- ============================================================

/--- Atualização de novos códigos que possuem a versão sem a concatenação da nrorg ---/
UPDATE NOVOCODIGO SET NRSEQUENCIAL = (SELECT LPAD(MAX(NRHISTVALEVINC),20,'0') FROM VAB_HISTVALEVINC WHERE NRORG = '20') WHERE CDCONTADOR = 'VAB_HISTVALEVINC' AND NRORG = '20';

UPDATE NOVOCODIGO SET NRSEQUENCIAL = (SELECT LPAD(MAX(NRHISTVALEVINC),20,'0') FROM VAB_HISTVALEVINC WHERE NRORG = '998') WHERE CDCONTADOR = 'VAB_HISTVALEVINC' AND NRORG = '998';

UPDATE NOVOCODIGO SET NRSEQUENCIAL = (SELECT LPAD(MAX(NRHISTVALEVINC),20,'0') FROM VAB_HISTVALEVINC WHERE NRORG = '1008') WHERE CDCONTADOR = 'VAB_HISTVALEVINC' AND NRORG = '1008';

UPDATE NOVOCODIGO SET NRSEQUENCIAL = (SELECT LPAD(MAX(NRHISTVALEVINC),20,'0') FROM VAB_HISTVALEVINC WHERE NRORG = '1024') WHERE CDCONTADOR = 'VAB_HISTVALEVINC' AND NRORG = '1024';

UPDATE NOVOCODIGO SET NRSEQUENCIAL = (SELECT LPAD(MAX(NRHISTVALEVINC),20,'0') FROM VAB_HISTVALEVINC WHERE NRORG = '1193') WHERE CDCONTADOR = 'VAB_HISTVALEVINC' AND NRORG = '1193';

/--- Adição de novos códigos que não possuem a versão sem a concatenação da nrorg ---/
INSERT INTO NOVOCODIGO
SELECT SUBSTR(CDCONTADOR, 0, 16) AS CDCONTADOR, NRSEQUENCIAL, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO FROM NOVOCODIGO
WHERE CDCONTADOR = 'VAB_HISTVALEVINC14';

INSERT INTO NOVOCODIGO
SELECT SUBSTR(CDCONTADOR, 0, 16) AS CDCONTADOR, NRSEQUENCIAL, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO FROM NOVOCODIGO
WHERE CDCONTADOR = 'VAB_HISTVALEVINC1019';

INSERT INTO NOVOCODIGO
SELECT SUBSTR(CDCONTADOR, 0, 16) AS CDCONTADOR, NRSEQUENCIAL, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO FROM NOVOCODIGO
WHERE CDCONTADOR = 'VAB_HISTVALEVINC1029';

INSERT INTO NOVOCODIGO
SELECT SUBSTR(CDCONTADOR, 0, 16) AS CDCONTADOR, NRSEQUENCIAL, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO FROM NOVOCODIGO
WHERE CDCONTADOR = 'VAB_HISTVALEVINC1038';

INSERT INTO NOVOCODIGO
SELECT SUBSTR(CDCONTADOR, 0, 16) AS CDCONTADOR, NRSEQUENCIAL, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO FROM NOVOCODIGO
WHERE CDCONTADOR = 'VAB_HISTVALEVINC1130';

INSERT INTO NOVOCODIGO
SELECT SUBSTR(CDCONTADOR, 0, 16) AS CDCONTADOR, NRSEQUENCIAL, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO FROM NOVOCODIGO
WHERE CDCONTADOR = 'VAB_HISTVALEVINC1157';

INSERT INTO NOVOCODIGO
SELECT SUBSTR(CDCONTADOR, 0, 16) AS CDCONTADOR, NRSEQUENCIAL, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO FROM NOVOCODIGO
WHERE CDCONTADOR = 'VAB_HISTVALEVINC1311';

INSERT INTO NOVOCODIGO
SELECT SUBSTR(CDCONTADOR, 0, 16) AS CDCONTADOR, NRSEQUENCIAL, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO FROM NOVOCODIGO
WHERE CDCONTADOR = 'VAB_HISTVALEVINC1313';

INSERT INTO NOVOCODIGO
SELECT SUBSTR(CDCONTADOR, 0, 16) AS CDCONTADOR, NRSEQUENCIAL, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO FROM NOVOCODIGO
WHERE CDCONTADOR = 'VAB_HISTVALEVINC1410';

INSERT INTO NOVOCODIGO
SELECT SUBSTR(CDCONTADOR, 0, 16) AS CDCONTADOR, NRSEQUENCIAL, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO FROM NOVOCODIGO
WHERE CDCONTADOR = 'VAB_HISTVALEVINC1506';

INSERT INTO NOVOCODIGO
SELECT SUBSTR(CDCONTADOR, 0, 16) AS CDCONTADOR, NRSEQUENCIAL, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO FROM NOVOCODIGO
WHERE CDCONTADOR = 'VAB_HISTVALEVINC1664';

INSERT INTO NOVOCODIGO
SELECT SUBSTR(CDCONTADOR, 0, 16) AS CDCONTADOR, NRSEQUENCIAL, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO FROM NOVOCODIGO
WHERE CDCONTADOR = 'VAB_HISTVALEVINC1963';

INSERT INTO NOVOCODIGO
SELECT SUBSTR(CDCONTADOR, 0, 16) AS CDCONTADOR, NRSEQUENCIAL, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO FROM NOVOCODIGO
WHERE CDCONTADOR = 'VAB_HISTVALEVINC2025';

INSERT INTO NOVOCODIGO
SELECT SUBSTR(CDCONTADOR, 0, 16) AS CDCONTADOR, NRSEQUENCIAL, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO FROM NOVOCODIGO
WHERE CDCONTADOR = 'VAB_HISTVALEVINC2233';

INSERT INTO NOVOCODIGO
SELECT SUBSTR(CDCONTADOR, 0, 16) AS CDCONTADOR, NRSEQUENCIAL, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO FROM NOVOCODIGO
WHERE CDCONTADOR = 'VAB_HISTVALEVINC2973';

INSERT INTO NOVOCODIGO
SELECT SUBSTR(CDCONTADOR, 0, 16) AS CDCONTADOR, NRSEQUENCIAL, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO FROM NOVOCODIGO
WHERE CDCONTADOR = 'VAB_HISTVALEVINC3094';

INSERT INTO NOVOCODIGO
SELECT SUBSTR(CDCONTADOR, 0, 16) AS CDCONTADOR, NRSEQUENCIAL, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO FROM NOVOCODIGO
WHERE CDCONTADOR = 'VAB_HISTVALEVINC3175';

INSERT INTO NOVOCODIGO
SELECT SUBSTR(CDCONTADOR, 0, 16) AS CDCONTADOR, NRSEQUENCIAL, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO FROM NOVOCODIGO
WHERE CDCONTADOR = 'VAB_HISTVALEVINC3260';

INSERT INTO NOVOCODIGO
SELECT SUBSTR(CDCONTADOR, 0, 16) AS CDCONTADOR, NRSEQUENCIAL, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO FROM NOVOCODIGO
WHERE CDCONTADOR = 'VAB_HISTVALEVINC3375';

INSERT INTO NOVOCODIGO
SELECT SUBSTR(CDCONTADOR, 0, 16) AS CDCONTADOR, NRSEQUENCIAL, NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, IDATIVO FROM NOVOCODIGO
WHERE CDCONTADOR = 'VAB_HISTVALEVINC3684';
