-- ============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 21.x 
--   Created on:     26/09/2023  12:00                        
--   Issue:          444718 - Tela Pre fechamento FGTS - Salvar Retorno Totalizador

-- ============================================================
-- Table: ESO_NAOPERIODFGTS
-- ============================================================

CREATE TABLE ESO_NAOPERIODFGTS
(
    NRORG                 NUMBER          NOT NULL,
    NRNAOPERIODFGTS       NUMBER          NOT NULL,
    NRENVIO               NUMBER          NOT NULL,
    CDMATRICULA           VARCHAR2(30)    NULL,
    CDCATEG               VARCHAR2(12)    NULL,
    VRBASEFGTSMENSAL      FLOAT(126)      NULL,
    VRBASEFGTS13          FLOAT(126)      NULL,
    VRDEPOSITOFGTS        FLOAT(126)      NULL,
    VRDEPOSITOFGTS13      FLOAT(126)      NULL,
    CDLOTACAO             VARCHAR2(30)    NULL,
    IDATIVO               VARCHAR2(1)     DEFAULT 'S' NOT NULL
    CONSTRAINT CKC_IDATIVO_NAOPERIODFGTS CHECK (IDATIVO IN ('N','S')),
    DTINCLUSAO            DATE            DEFAULT SYSDATE NOT NULL,
    DTULTATU              DATE            NULL,
    NRORGINCLUSAO         NUMBER(22)      DEFAULT 1 NULL,
    CDOPERINCLUSAO        VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU           NUMBER(22)      DEFAULT 1 NULL,
    CDOPERULTATU          VARCHAR2(12)    DEFAULT '1' NULL,
    CONSTRAINT PK_ESO_NAOPERIODFGTS PRIMARY KEY (NRORG, NRNAOPERIODFGTS),
    CONSTRAINT FK_ESO_NAOPERIODFGTS FOREIGN KEY (NRORG, NRENVIO)  REFERENCES ESO_NAOPERIODICO (NRORG, NRENVIO)
)