-- ============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 21.x 
--   Created on:     05/09/2024  10:50                   
--   Issue:          SPRT [38] - 494256 Criar Cadastro de Liminar - Fopag

-- ============================================================
-- Table: GPE_PROCADMJUDESTRUT
-- ============================================================


CREATE TABLE GPE_PROCADMJUDESTRUT
(
    NRORG                 NUMBER          NOT NULL,
    NRPROCADMJUDESTRUT    NUMBER	      NOT NULL,
    NRESTRUTURAM          NUMBER          NOT NULL,
    NRPROCESSADMJUD       NUMBER          NOT NULL,
    CDTERCEIRO            VARCHAR2(4)     NOT NULL,
    CDINDSUSP             VARCHAR2(2)     NOT NULL,
    IDATIVO               VARCHAR2(1)     DEFAULT 'S' NOT NULL
    CONSTRAINT CKC_IDATIVO_GPE_PROCADMJUDESTRUT CHECK (IDATIVO IN ('N','S')),
    DTINCLUSAO            DATE            DEFAULT SYSDATE NOT NULL,
    DTULTATU              DATE            NULL,
    NRORGINCLUSAO         NUMBER(22)      DEFAULT 1 NULL,
    CDOPERINCLUSAO        VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU           NUMBER(22)      DEFAULT 1 NULL,
    CDOPERULTATU          VARCHAR2(12)    DEFAULT '1' NULL,   
    CONSTRAINT PK_NRPROCADMJUDESTRUT PRIMARY KEY (NRORG, NRPROCADMJUDESTRUT),
    CONSTRAINT FK_PROCESTRUT FOREIGN KEY(NRORG, NRESTRUTURAM) REFERENCES ESTRUTURAM (NRORG, NRESTRUTURAM),
    CONSTRAINT FK_CADPROCADM FOREIGN KEY(NRORG, NRPROCESSADMJUD) REFERENCES GPE_PROCESSADMJUD (NRORG, NRPROCESSADMJUD)
);
