/**********************************************************************************************************************/
/**** PROJETO GRUPO CICOPAL 2022                                                                                     **/
/**** IMPLANTAO DOS FUNCIONARIOS                                                                                  **/
/**** SCRITP DE PREPARAO DA MIGRAO                                                                               **/
/**** ESSE SCRIPT GERA TABELA AUXILIAR (TB_AUX_HISTORIAFASTAMENTO)                                                      **/
--SELECT * FROM TB_AUX_HISTORICOAFASTAMENTO WHERE R8_TIPOAFA NOT IN ('001', '002')  /* Ferias, Recesso */  AND TRIM(R8_TIPOAFA) IS NOT  NULL;
--DROP TABLE TB_AUX_HISTORICOAFASTAMENTO;
/**********************************************************************************************************************/

--------------------------------------------------------
-- GERAO DA TABELA TB_AUX_HISTORICOAFASTAMENTO
--------------------------------------------------------
CREATE TABLE TB_AUX_HISTORICOAFASTAMENTO AS ( 
SELECT 
	'01' AS CodEmp,		/* Cod Emppresa */
	afast.R8_FILIAL,	/* Filial */
	afast.R8_MAT,		/* Matricula */
	afast.R8_TIPOAFA,	/* Cod Tipo Afastamento */
	afast.R8_DATA,		/* Data */
	afast.R8_DATAINI,	/* Data Inicial */
	afast.R8_DATAFIM,	/* Data Final */
	afast.R8_DURACAO,	/* Duracao */
	afast.R8_OBSAFAS,	/* Observacao Afastamento */
	afast.R8_CNPJCES,	/* CNPJ Cessionario */
	afast.R8_CNPJSIN,	/* CNPJ Sindicato */
	afast.R8_TPPROC,	/* Tipo de Processo Jur */
    afast.R8_TIPO	/* Tipo Afastamento */
FROM
	SIGAP12.SR8010 afast
WHERE
	afast.D_E_L_E_T_ <> '*'

UNION ALL

SELECT 
	'06' AS CodEmp,
	afast.R8_FILIAL,	/* Filial */
	afast.R8_MAT,		/* Matr?cula */
	afast.R8_TIPOAFA,	/* Cod Tipo Afastamento */
	afast.R8_DATA,		/* Data */
	afast.R8_DATAINI,	/* Data Inicial */
	afast.R8_DATAFIM,	/* Data Final */
	afast.R8_DURACAO,	/* Dura??o */
	afast.R8_OBSAFAS,	/* Observa??o Afastamento */
	afast.R8_CNPJCES,	/* CNPJ Cession?rio */
	afast.R8_CNPJSIN,	/* CNPJ Sindicato */
	afast.R8_TPPROC, 	/* Tipo de Processo Jur */
    afast.R8_TIPO	/* Tipo Afastamento */
FROM
	SIGAP12.SR8060  afast
WHERE
	afast.D_E_L_E_T_ <> '*'
);