/* Cadastro de Agncias nos COLABORADORES*/
SELECT DISTINCT
	RIGHT(F.CODBAN,3) AS '1CODIGO',
	RIGHT('0000' + CONVERT(VARCHAR, F.CODAGE), 4)  AS '2CODAGE',
	'' AS '3DESCRICAO'		
FROM R034FUN F --WHERE F.CODBAN ='237'	AND F.CODAGE='0'
ORDER BY 1,2

/* Cadastro de Agncias na tabela de agencias*/
SELECT DISTINCT
	RIGHT('0000' + CONVERT(VARCHAR, age.codage), 4) AS '1CODIGO',		
	RTRIM(age.digage) AS '2DIGITO_VERIFICADOR',												        
    RTRIM(age.nomage) AS '3DESCRICAO',															                 
	RTRIM(age.codcid) AS '4CODMUNICIPIO',												          
	CASE RTRIM(UPPER(age.codest))
		WHEN 'AC' THEN '0'
		WHEN 'AL' THEN '1'
		WHEN 'AM' THEN '2'
		WHEN 'AP' THEN '3'
		WHEN 'BA' THEN '4'
		WHEN 'CE' THEN '5'
		WHEN 'DF' THEN '6'
		WHEN 'ES' THEN '7'
		WHEN 'GO' THEN '8'
		WHEN 'MA' THEN '9'
		WHEN 'MG' THEN '10'
		WHEN 'MS' THEN '11'
		WHEN 'MT' THEN '12'
		WHEN 'PA' THEN '13'
		WHEN 'PB' THEN '14'
		WHEN 'PE' THEN '15'
		WHEN 'PI' THEN '16'
		WHEN 'PR' THEN '17'
		WHEN 'RJ' THEN '18'
		WHEN 'RN' THEN '19'
		WHEN 'RO' THEN '20'
		WHEN 'RR' THEN '21'
		WHEN 'RS' THEN '22'
		WHEN 'SC' THEN '23'
		WHEN 'SE' THEN '24'
		WHEN 'SP' THEN '25'
		WHEN 'TO' THEN '26' 
		ELSE CASE RTRIM(age.codcid) 
				WHEN '3549805' THEN '25' --SO JOS DO RIO PRETO
				WHEN '3555604' THEN '25' --UCHOA
				WHEN '3540804' THEN '25' --POTIRENDABA				
			 END
	END AS '5CODESTADO',			
	age.codban AS '6CODBANCO',	
	CASE age.codpai
		WHEN 1 THEN '0' /* Brasil */
		ELSE '0'
	END AS '7CODPAIS'		
FROM 
	R012BAN ban
	LEFT JOIN R012AGE age ON ban.codban = age.codban
	WHERE BAN.CODBAN IN ('237','192')
ORDER BY
	6, 1

/* Cadastro de Agncias X Agencias utilizadas nos colaboradores*/
SELECT distinct
	RIGHT(FUN.CODBAN,3) AS 'COD_BAN_colab',
	FUN.CODAGE AS 'COD_AGE_colab',
	'' AS '3DESCRICAO'	,
	AGE.CODAGE AS 'COD_AGE',
	AGE.CODBAN AS 'COD_BAN'	
	,(SELECT COUNT (F.numcad) FROM R034FUN F LEFT JOIN R042RCM rc ON 
														F.NUMEMP = rc.NUMEMP AND
														F.TIPCOL = rc.TIPCOL AND
														F.NUMCAD = rc.NUMCAD 
							WHERE FUN.CODBAN=CODBAN AND FUN.CODAGE=CODAGE AND RC.datdem IS not NULL ) AS "QTD_COLAB_INATIVO"
	,(SELECT COUNT (F.numcad) FROM R034FUN F LEFT JOIN R042RCM rc ON 
														F.NUMEMP = rc.NUMEMP AND
														F.TIPCOL = rc.TIPCOL AND
														F.NUMCAD = rc.NUMCAD 
							WHERE FUN.CODBAN=CODBAN AND FUN.CODAGE=CODAGE AND RC.datdem IS NULL ) AS "QTD_COLAB_ATIVO"
	,(SELECT COUNT (F.numcad) FROM R034FUN F LEFT JOIN R042RCM rc ON 
														F.NUMEMP = rc.NUMEMP AND
														F.TIPCOL = rc.TIPCOL AND
														F.NUMCAD = rc.NUMCAD 
							WHERE FUN.CODBAN=CODBAN AND FUN.CODAGE=CODAGE AND REPLACE(CONVERT(VARCHAR(10), RC.datdem, 111), '/', '')>'20100101') AS "QTD_COLAB_TOTAL"
FROM R034FUN FUN LEFT JOIN R012AGE age 
					ON FUN.codban = age.codban 
					AND RIGHT('0000' + CONVERT(VARCHAR, FUN.codage), 4)=RIGHT('0000' + CONVERT(VARCHAR, age.codage), 4)
LEFT JOIN R042RCM rcm ON 
       FUN.NUMEMP = rcm.NUMEMP AND
	   FUN.TIPCOL = rcm.TIPCOL AND
	   FUN.NUMCAD = rcm.NUMCAD 
   LEFT JOIN R038HVI AVI ON 
      AVI.numemp = RCM.numemp AND
	  AVI.numcad = RCM.numcad AND
	  AVI.tipcol = RCM.tipcol
   LEFT JOIN R042AVI DTA ON 
      DTA.numemp = RCM.numemp AND
	  DTA.numcad = RCM.numcad AND
	  DTA.tipcol = RCM.tipcol

