USE [ORIGEM_GHC_SENIOR_SJRP_27_01_2023_GOLIVE]
SELECT distinct
   '00100'    AS "0001 Código d*reiniciao leiaute",
   ''         AS "0002 Pessoa ID - colaborador",
   CASE WHEN fun.numemp = 1 THEN 304
		 WHEN fun.numemp = 2 THEN 303
		 ELSE '' 
	END AS "0003 Empresa do contrato",
   --'999' AS "0003 Empresa do contrato",
   dbo.fnc_depara(CAST(fun.numemp AS VARCHAR)+'_'+CAST(fun.tipcol AS VARCHAR) + '_'+CAST(fun.numcad AS VARCHAR), 'MATRICULA', 'HMC-IMC-SJRP')  AS "0004 Matrícula do colaborador",
   dep.CODDEP AS "0005 Sequencial único que representa o Dependente",
   CASE WHEN dep.NUMCPF > 0  THEN  right('000000000000'+CONVERT(VARCHAR, dep.NUMCPF),11) ELSE '' END AS "0006 CPF",
   ''         AS "0007 Pessoa ID - Dependente",
      CASE
      WHEN (CONVERT(VARCHAR,REPLACE(CONVERT(DATE,dep.DATNAS, 103), '-', ''))) < 
		   (CONVERT(VARCHAR,REPLACE(CONVERT(DATE,fun.DATADM, 103), '-', '')))
      THEN REPLACE(CONVERT(VARCHAR(10), fun.DATADM, 103), '/', '')
      ELSE REPLACE(CONVERT(VARCHAR(10), DEP.DATNAS, 103), '/', '')
   END        AS "0008 Data de ativação do Dependente",
   ''         AS "0009 Data fim de ativação do",
   ''         AS "0010 Motivo da inativação do dependente",
   dep.NOMDEP AS "0011 Nome",
   REPLACE(CONVERT(VARCHAR(10), DEP.DATNAS, 103), '/', '') AS "0012 Data de nascimento",
   dep.TIPSEX AS "0013 Sexo",
   case dep.grapar 
      when 3 then dbo.fnc_depara(convert(varchar, dep.GRAPAR) + dep.TIPSEX , 'PARENTESCO','ISL')
	  else  dbo.fnc_depara(dep.GRAPAR, 'PARENTESCO','ISL')
   end AS "0014 Parentesco",
   ''         AS "0015 Relação de dependência",
   dbo.fnc_depara(dep.GraIns, 'GRAUINST', 'ISL') AS "0016 Grau de instrução",
   dbo.fnc_depara(dep.ESTCIV, 'ESTCIVIL'   , 'ISL') AS "0017 Estado civil",
   ''         AS "0018 Data do casamento", 
   ''         AS "0019 União estável", 
   ''         AS "0020 Data da união estável",
   '2'	      AS "0021 Tipo da filiação 1",
   CASE WHEN LEN(dep.NomMae) > 1  then dep.nommae else 'NAO INFORMADO' end AS "0022 Nome da filiação 1",
   '' AS "0023 Tipo da filiação 2", 
   '' AS "0024 Nome da filiação 2",
   '' AS "0025 Responsável legal considerado na emissão de relatórios oficiais", 
   '' AS "0026 Incluir no arquivo Susep",  
   isnull(dep.NumCid, '') AS "0027 Número da Identidade",
   --   isnull(dep.EmiCid, getdate())
   case when isnull(dep.NumCid, '') = '' then '' else 'SSP' end AS "0028 Órgão emissor da Identidade",
   CASE WHEN YEAR(dep.DexCid) = 1900 OR dep.DexCid IS NULL THEN '' ELSE REPLACE(CONVERT(VARCHAR(10), DEP.DEXCID, 103), '/', '') END AS "0029 Data da emissão da Identidade",                 
   CASE WHEN isnull(dep.NumCid, '') = '' THEN ''
   ELSE REPLACE(dbo.fnc_depara(isnull(dep.EstCid, 'SP'), 'UF','ISL'),'  - DePara Não Encontrado','25')
   END AS "0030 Estado da Identidade",                    -- 0030 Estado da Identidade
   '' AS "0031 Número do RIC",                    -- 0031 Número do RIC
   '' AS "0032 Série do RIC",                    -- 0032 Série do RIC
   '' AS "0033 Data de emissão do RIC",                    -- 0033 Data de emissão do RIC
   '' AS "0034 Data de validade do RIC",                    -- 0034 Data de validade do RIC
   '' AS "0035 Órgão emissor do RIC",                    -- 0035 Órgão emissor do RIC
   '' AS "0036 Estado do RIC",                    -- 0036 Estado do RIC
   '' AS "0037 Número do CNS",                    -- 0037 Número do CNS
   '' AS "0038 Via do CNS",                    -- 0038 Via do CNS
	case when MatNas <> '' then '1' else '' end AS "0039 Tipo da Certidão",                    -- 0039 Tipo da Certidão
	ISNULL(MatNas,'') AS "0040 Matrícula da Certidão",                    -- 0040 Matrícula da Certidão
	ISNULL(NumCer,'') AS "0041 Número da Certidão",                    -- 0041 Número da Certidão
	'' AS "0042 Livro da Certidão",                    -- 0042 Livro da Certidão
	'' AS "0043 Folha da Certidão",                    -- 0043 Folha da Certidão
	'' AS "0044 Cartório da Certidão",                    -- 0044 Cartório da Certidão
	'' AS "0045 Estado da Certidão",                    -- 0045 Estado da Certidão
	'' AS "0046 Município da Certidão",                    -- 0046 Município da Certidão
	'' AS "0047 Data de emissão da Certidão",                    -- 0047 Data de emissão da Certidão
	'' AS "0048 Número da DNV da Certidão",                    -- 0048 Número da DNV da Certidão
	CASE 
		when ISNULL(NumCer,'') = '' then ''
		WHEN YEAR(ENTCER) > 1900 THEN REPLACE(CONVERT(VARCHAR(10), ENTCER, 103), '/', '') 
	ELSE '' END AS "0049 Data de entrega da certidão",                    -- 0049 Data de entrega da certidão
	'' AS "0050 Data da última vacinação",                    -- 0050 Data da última vacinação
	'' AS "0051 Data de vencimento da Carteira de Vacinação",                    -- 0051 Data de vencimento da Carteira de Vacinação
	'' AS "0052 Data da entrega da Carteira de Vacinação",                    -- 0052 Data da entrega da Carteira de Vacinação
	'' AS "0053 Instituição Escolar",                    -- 0053 Instituição Escolar
	'' AS "0054 Série/Ano Escolar",                    -- 0054 Série/Ano Escolar
	'' AS "0055 Data da entrega da Frequência Escolar",                    -- 0055 Data da entrega da Frequência Escolar
	'' AS "0056 Data de vencimento da Frequência Escolar",                    -- 0056 Data de vencimento da Frequência Escolar
    CASE WHEN dep.limirf >= 21 THEN  
         CASE
            WHEN (CONVERT(VARCHAR,REPLACE(CONVERT(DATE,dep.DATNAS, 103), '-', ''))) < 
		         (CONVERT(VARCHAR,REPLACE(CONVERT(DATE,fun.DATADM, 103), '-', '')))
            THEN REPLACE(CONVERT(VARCHAR(10), fun.DATADM, 103), '/', '')
            ELSE REPLACE(CONVERT(VARCHAR(10), DEP.DATNAS, 103), '/', '')
         END 
   ELSE '' END AS "0057 Data de ativação do IRRF",                    -- 0057 Data de ativação do IRRF
   '' AS "0058 Data fim de ativação do IRRF",                    -- 0058 Data fim de ativação do IRRF
   CASE 
      WHEN dep.[GRAPAR] <> 1 OR FLOOR(DATEDIFF(YEAR, CONVERT(DATE,dep.[DATNAS], 103), '01/04/2020')) > dep.[LIMSAF] 
	  THEN	''
	  WHEN dep.[GRAPAR] = 1 AND 
	       FLOOR(DATEDIFF(YEAR, CONVERT(DATE,dep.[DATNAS], 103), '01/04/2020'))	<= dep.[LIMSAF]	AND
          (CONVERT(VARCHAR,REPLACE(CONVERT(DATE,dep.[DATNAS], 103), '-', ''))) < (CONVERT(VARCHAR,REPLACE(CONVERT(DATE,fun.[DATADM], 103), '-', ''))) 
      THEN REPLACE(CONVERT(VARCHAR(10), fun.DATADM, 103), '/', '') 
      WHEN dep.[GRAPAR] = 1 AND  
		   FLOOR(DATEDIFF(YEAR, CONVERT(DATE,dep.[DATNAS], 103), '01/04/2020')) 	<= dep.[LIMSAF]	AND
		  (CONVERT(VARCHAR,REPLACE(CONVERT(DATE,dep.[DATNAS], 103), '-', ''))) >= CONVERT(VARCHAR,REPLACE(CONVERT(DATE,fun.[DATADM], 103), '-', '')) 
      THEN REPLACE(CONVERT(VARCHAR(10), DEP.DATNAS, 103), '/', '') 
      ELSE  '1' 
   END	AS "0059 Data de ativação do Salário-família",                    -- 0059 Data de ativação do Salário-família
   '' AS "0060 Data fim de ativação do Salário-família",                    -- 0060 Data fim de ativação do Salário-família
   'N' AS "0061 Permanente",                    -- 0061 Permanente
   '' AS "0062 CEP do endereço",                    -- 0062 CEP do endereço
	'' AS "0063 Tipo do logradouro",                    -- 0063 Tipo do logradouro
	'' AS "0064 Logradouro",                    -- 0064 Logradouro
	'' AS "0065 Número",                    -- 0065 Número
	'' AS "0066 Complemento",                    -- 0066 Complemento
	'' AS "0067 Bairro",                    -- 0067 Bairro
	'' AS "0068 Estado",                    -- 0068 Estado
	'' AS "0069 Município",                    -- 0069 Município
	'' AS "0070 Caixa postal",                    -- 0070 Caixa postal
	'' AS "0071 CEP da caixa postal",                    -- 0071 CEP da caixa postal
	dep.coddep AS "0072 Código do Dependente" ,                   -- 0072 Código do Dependente,
	'' as "0073 genêro",
	'' as "0074",
	'' as "0075"
FROM 
   R036DEP DEP
   INNER JOIN R034FUN FUN ON 
      DEP.NUMEMP = FUN.NUMEMP AND
	  DEP.TIPCOL = FUN.TIPCOL AND
	  DEP.NUMCAD = FUN.NUMCAD
   LEFT JOIN R036IRF IR ON
      IR.NUMEMP = DEP.NUMEMP AND
	  IR.TIPCOL = DEP.TIPCOL AND
	  IR.NUMCAD = DEP.NUMCAD and
	  ir.coddep = dep.coddep
 INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG
   ON FUN.numemp=MIG.NUMEMP AND FUN.TIPCOL=MIG.TIPCOL AND FUN.numCAD=MIG.NUMCAD

WHERE
   fun.tipcol = 1 and
   (fun.sitafa <> 7 or
    (fun.sitafa = 7 and fun.datafa >= '01/01/2017')) --Demitido
	AND fun.cateso <> 701
	--and fun.numcad in (725)
	--AND dbo.fnc_depara( DEP.NUMCAD, 'MATRICULA', 'ISL') NOT LIKE ('%DePara Não Encontrado') 
	--AND dbo.fnc_depara( DEP.NUMCAD, 'MATRICULA', 'ISL') > 6183
	--AND FUN.NUMCAD IN (34002673,34002671,34002675,34002674,34002672)
	AND

	CASE WHEN fun.numemp = 1 THEN '304'
		 WHEN fun.numemp = 2 THEN '303'
		 ELSE '' 
	END+'_'+dbo.fnc_depara( CAST(fun.numemp AS VARCHAR)+'_'+CAST(fun.tipcol AS VARCHAR) + '_'+CAST(fun.numcad AS VARCHAR), 'MATRICULA', 'HMC-IMC-SJRP')       
   IN	('304_153'
,'304_154'
,'304_155'
,'304_156'
,'304_157'
,'304_158'
,'304_233'
,'303_602052'
,'303_602053'
,'303_602054'
,'303_602055'
,'303_602056'
,'303_602057'
,'303_602058'
,'303_602059'
,'303_602060'
,'303_602061'
,'303_602062'
,'303_602063'
,'303_602064'
,'303_602065'
,'303_602066'
,'303_602067'
,'303_602068'
,'303_602069'
,'303_602070'
,'303_602071'
,'303_602072'
,'303_602073'
,'303_602074'
,'303_602075'
,'303_602076'
,'303_602077'
,'303_602078'
,'303_602079'
,'303_602080'
,'303_602081'
,'303_602082'
,'303_602083')
order by 3, 4, 5
