/**********************************************************************************************************************/
/********** PROJETO GHC - BASE SENIOR - SJRP - 2022 *******************************************************************/
/********** MIGRAO DE FICHA FINANCEIRA ******************************************************************************/
/**********************************************************************************************************************/
/* SCRIPT 02 - MIGRAO DOS EVENTOS DE PROVENTOS, DESCONTOS E RESULTADO A PARTIR DO DEPARA DE EVENTOS                 */
/**********************************************************************************************************************/
/* SOMENTE NUMEMP 1 E 2                                                                                               */
/**********************************************************************************************************************/



--> CRIANDO VIEW COM A APLICAO DO DEPARA EM TODOS AS FOLHAS
------------------------------------------------------------------------------------------------------------------------------------------------------------
ALTER VIEW VW_FICHA_FINANCEIRA_SENIOR AS
/*========================================================================================================================================================*/
/* EVENTOS DE FRIAS: TABELA R040FEV E CONSIDERAR SOMENTE OS EVENTOS DO DEPARA INDICADOSA COM FOLHA "FER"                                                 */
/*========================================================================================================================================================*/
SELECT VA.NUMEMP,
       CASE WHEN VA.NUMEMP = 1 THEN 304
		    WHEN VA.NUMEMP = 2 THEN 303
		    ELSE 0
	   END AS EMPRESA_LG, 
       VA.TIPCOL,
	   VA.NUMCAD,
	   DBO.FNC_DEPARA( CAST(FUN.NUMEMP AS VARCHAR)+'_'+CAST(FUN.TIPCOL AS VARCHAR)+'_'+CAST(FUN.NUMCAD AS VARCHAR),'MATRICULA','HMC-IMC-SJRP') AS MATRICULA,
	   CASE WHEN MIG.sitafa <> 7 THEN '' ELSE MIG.DATAFA END AS DATREC,
	   VA.INIFER AS DATA_REFER,
	   REPLACE(RIGHT(CONVERT(VARCHAR,VA.INIFER,103),7),'/','') AS REFER,
	   CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.INIFER,112),6)) AS REFER_NUM,
	   0 AS CODCAL,
	   0 AS TIPCAL,
	   'TAB FERIAS' AS DESC_TIPCAL,
	   VA.TABEVE,
	   VA.CODEVE,
	   EV.DESEVE,
	   EV.TIPEVE,
	   CASE EV.TIPEVE WHEN 1 THEN 'PROVENTO'
			          WHEN 2 THEN 'VANTAGEM'
			          WHEN 3 THEN 'DESCONTO'
			          WHEN 4 THEN 'OUTROS'
			          WHEN 5 THEN 'OUTROS ENV. PROVENTO'
			          WHEN 6 THEN 'OUTROS ENV. DESCONTO'
	   END AS DESC_TIPEVE,
	   VA.REFEVE,
	   VA.VALEVE,
	   DPE.COD_EVENTO_DE,
	   DPE.TIPO_EVENTO_DE,
	   DPE.COD_FOLHA_DE,
	   DPE.COD_EVENTO_LG,
	   DPE.EVENTO_LG AS EVENTO_LG_DEPARA,
	   EVLG.EVENTO AS EVENTO_LG,
	   DPE.TIPO_EVENTO_LG AS TIPO_EVENTO_LG_DEPARA,
	   EVLG.CODIGO_TIPO_EVENTO,
       EVLG.TIPO_EVENTO,
	   CASE WHEN ISNULL(DPE.COD_FOLHA_LG,'0') = 0 THEN 0 ELSE CONVERT(INT,DPE.COD_FOLHA_LG) END AS COD_FOLHA_LG,
	   'FERIAS' AS DESC_FOLHA_LG,
	   DPE.COD_EVENTO_REFER_LG,
	   DPE.EVENTO_REFER_LG,
	   DPE.COD_REGRA_EVE_REFER,
	   DPE.APLIC_REGRA_EVE_REFER
  FROM R040FEV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP=MIG.NUMEMP AND FUN.TIPCOL=MIG.TIPCOL AND FUN.NUMCAD=MIG.NUMCAD)
	   INNER JOIN R008EVC EV --> TABELA SENIOR COM DE CADASTRO DE EVENTOS
	   ON (EV.CODEVE = VA.CODEVE)
	   INNER JOIN DEPARA_EVENTOS_ATUAL DPE --> TABELA DE DEPARA DE EVENTOS
	   ON (DPE.COD_EVENTO_DE = VA.CODEVE AND DPE.COD_FOLHA_DE = 'FER')
	   INNER JOIN Eventos_LG EVLG --> TABELA AUXILIAR COM OS EVENTOS CADASTRADOS NA BASE DA LG
	   ON (EVLG.CODIGO_EVENTO = DPE.COD_EVENTO_LG)
 --WHERE VA.NUMEMP = 2 AND VA.NUMCAD = 597 AND CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.INIFER,112),6)) = 202207
/*========================================================================================================================================================*/
UNION ALL
/*========================================================================================================================================================*/
/* EVENTOS DE RESCISO: TABELA R046VER E CONSIDERAR SOMENTE OS EVENTOS DO DEPARA NO INDICADOS COM FOLHA "FER"                                            */
/*                      CONSIDERAR SOMETE DEMITIDOS E OS EVENTOS CALCULADOS NO MES DA RESCISO                                                            */
/*========================================================================================================================================================*/
SELECT VA.NUMEMP,
       CASE WHEN VA.NUMEMP = 1 THEN 304
		    WHEN VA.NUMEMP = 2 THEN 303
		    ELSE 0
	   END AS EMPRESA_LG,
       VA.TIPCOL,
	   VA.NUMCAD,
	   DBO.FNC_DEPARA( CAST(FUN.NUMEMP AS VARCHAR)+'_'+CAST(FUN.TIPCOL AS VARCHAR)+'_'+CAST(FUN.NUMCAD AS VARCHAR),'MATRICULA','HMC-IMC-SJRP') AS MATRICULA,
	   MIG.DATAFA AS DATREC,
	   CA.PERREF AS DATA_REFER,
	   REPLACE(RIGHT(CONVERT(VARCHAR,CA.PERREF,103),7),'/','') AS REFER,
	   CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,CA.PERREF,112),6)) AS REFER_NUM,
	   CA.CODCAL,
	   CA.TIPCAL,
	   TC.DESCRICAO AS DESC_TIPCAL,
	   VA.TABEVE,
	   VA.CODEVE,
	   EV.DESEVE,
	   EV.TIPEVE,
	   CASE EV.TIPEVE WHEN 1 THEN 'PROVENTO'
			          WHEN 2 THEN 'VANTAGEM'
			          WHEN 3 THEN 'DESCONTO'
			          WHEN 4 THEN 'OUTROS'
			          WHEN 5 THEN 'OUTROS ENV. PROVENTO'
			          WHEN 6 THEN 'OUTROS ENV. DESCONTO'
	   END AS DESC_TIPEVE,
	   VA.REFEVE,
	   VA.VALEVE,
	   DPE.COD_EVENTO_DE,
	   DPE.TIPO_EVENTO_DE,
	   DPE.COD_FOLHA_DE,
	   DPE.COD_EVENTO_LG,
	   DPE.EVENTO_LG AS EVENTO_LG_DEPARA,
	   EVLG.EVENTO AS EVENTO_LG,
	   DPE.TIPO_EVENTO_LG AS TIPO_EVENTO_LG_DEPARA,
	   EVLG.CODIGO_TIPO_EVENTO,
       EVLG.TIPO_EVENTO,
	   5 AS COD_FOLHA_LG,
	   'RESCISAO' AS DESC_FOLHA_LG,
	   DPE.COD_EVENTO_REFER_LG,
	   DPE.EVENTO_REFER_LG,
	   DPE.COD_REGRA_EVE_REFER,
	   DPE.APLIC_REGRA_EVE_REFER
  FROM R046VER VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R044CAL CA --> TABELA DE CALCULOS PROCESSADOS NA SENIOR
	   ON (CA.NUMEMP = VA.NUMEMP AND CA.CODCAL = VA.CODCAL AND CA.TIPCAL = 11)
	   INNER JOIN TIPOCALCULO_SENIOR TC --> TABELA AUXILIAR COM OS TIPOS DE CALCULOS DA SENIOR
	   ON (TC.CODIGO = CA.tipcal)
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP=MIG.NUMEMP AND FUN.TIPCOL=MIG.TIPCOL AND FUN.NUMCAD=MIG.NUMCAD AND MIG.SITAFA = 7) --> SOMENTE DEMITIDOS (10.696)
	   INNER JOIN R008EVC EV --> TABELA SENIOR COM DE CADASTRO DE EVENTOS
	   ON (EV.CODEVE = VA.CODEVE)
	   INNER JOIN DEPARA_EVENTOS_ATUAL DPE --> TABELA DE DEPARA DE EVENTOS
	   ON (DPE.COD_EVENTO_DE = VA.CODEVE AND DPE.COD_FOLHA_DE <> 'FER' AND DPE.COD_FOLHA_LG IN (0,5))
	   INNER JOIN EVENTOS_LG EVLG --> TABELA AUXILIAR COM OS EVENTOS CADASTRADOS NA BASE DA LG
	   ON (EVLG.CODIGO_EVENTO = DPE.COD_EVENTO_LG)
 WHERE CONVERT(BIGINT,RIGHT(MIG.DATAFA,4) + SUBSTRING(MIG.DATAFA,4,2)) = CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,CA.PERREF,112),6))
   --AND VA.NUMEMP = 1 AND VA.NUMCAD = 8831 
/*========================================================================================================================================================*/
UNION ALL
/*========================================================================================================================================================*/
/* EVENTOS DE RESCISO COMPLEMENTAR DENTRO DO MES: TABELA R046VER E CONSIDERAR SOMENTE OS EVENTOS DO DEPARA NO INDICADOS COM FOLHA "FER"                 */
/*                      CONSIDERAR SOMENTE DEMITIDOS E OS EVENTOS CALCULADOS NO MES DA RESCISO E COM TIPO DO CALCULO 15                                  */
/*========================================================================================================================================================*/
SELECT VA.NUMEMP,
       CASE WHEN VA.NUMEMP = 1 THEN 304
		    WHEN VA.NUMEMP = 2 THEN 303
		    ELSE 0
	   END AS EMPRESA_LG,
       VA.TIPCOL,
	   VA.NUMCAD,
	   DBO.FNC_DEPARA( CAST(FUN.NUMEMP AS VARCHAR)+'_'+CAST(FUN.TIPCOL AS VARCHAR)+'_'+CAST(FUN.NUMCAD AS VARCHAR),'MATRICULA','HMC-IMC-SJRP') AS MATRICULA,
	   MIG.DATAFA AS DATREC,
	   CA.PERREF AS DATA_REFER,
	   REPLACE(RIGHT(CONVERT(VARCHAR,CA.PERREF,103),7),'/','') AS REFER,
	   CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,CA.PERREF,112),6)) AS REFER_NUM,
	   CA.CODCAL,
	   CA.TIPCAL,
	   TC.DESCRICAO AS DESC_TIPCAL,
	   VA.TABEVE,
	   VA.CODEVE,
	   EV.DESEVE,
	   EV.TIPEVE,
	   CASE EV.TIPEVE WHEN 1 THEN 'PROVENTO'
			          WHEN 2 THEN 'VANTAGEM'
			          WHEN 3 THEN 'DESCONTO'
			          WHEN 4 THEN 'OUTROS'
			          WHEN 5 THEN 'OUTROS ENV. PROVENTO'
			          WHEN 6 THEN 'OUTROS ENV. DESCONTO'
	   END AS DESC_TIPEVE,
	   VA.REFEVE,
	   VA.VALEVE,
	   DPE.COD_EVENTO_DE,
	   DPE.TIPO_EVENTO_DE,
	   DPE.COD_FOLHA_DE,
	   DPE.COD_EVENTO_LG,
	   DPE.EVENTO_LG AS EVENTO_LG_DEPARA,
	   EVLG.EVENTO AS EVENTO_LG,
	   DPE.TIPO_EVENTO_LG AS TIPO_EVENTO_LG_DEPARA,
	   EVLG.CODIGO_TIPO_EVENTO,
       EVLG.TIPO_EVENTO,
	   7 AS COD_FOLHA_LG,
	   'RESCISAO COMP NO MES' AS DESC_FOLHA_LG,
	   DPE.COD_EVENTO_REFER_LG,
	   DPE.EVENTO_REFER_LG,
	   DPE.COD_REGRA_EVE_REFER,
	   DPE.APLIC_REGRA_EVE_REFER
  FROM R046VER VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R044CAL CA --> TABELA DE CALCULOS PROCESSADOS NA SENIOR
	   ON (CA.NUMEMP = VA.NUMEMP AND CA.CODCAL = VA.CODCAL AND CA.TIPCAL = 15)
	   INNER JOIN TIPOCALCULO_SENIOR TC --> TABELA AUXILIAR COM OS TIPOS DE CALCULOS DA SENIOR
	   ON (TC.CODIGO = CA.tipcal)
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP=MIG.NUMEMP AND FUN.TIPCOL=MIG.TIPCOL AND FUN.NUMCAD=MIG.NUMCAD AND MIG.SITAFA = 7) --> SOMENTE DEMITIDOS 
	   INNER JOIN R008EVC EV --> TABELA SENIOR COM DE CADASTRO DE EVENTOS
	   ON (EV.CODEVE = VA.CODEVE)
	   INNER JOIN DEPARA_EVENTOS_ATUAL DPE --> TABELA DE DEPARA DE EVENTOS
	   ON (DPE.COD_EVENTO_DE = VA.CODEVE AND DPE.COD_FOLHA_DE <> 'FER' AND DPE.COD_FOLHA_LG IN (0,5))
	   INNER JOIN EVENTOS_LG EVLG --> TABELA AUXILIAR COM OS EVENTOS CADASTRADOS NA BASE DA LG
	   ON (EVLG.CODIGO_EVENTO = DPE.COD_EVENTO_LG)
 WHERE CONVERT(BIGINT,RIGHT(MIG.DATAFA,4) + SUBSTRING(MIG.DATAFA,4,2)) = CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,CA.PERREF,112),6))
   --AND VA.NUMEMP = 1 AND VA.NUMCAD = 8831 
/*========================================================================================================================================================*/
UNION ALL
/*========================================================================================================================================================*/
/* EVENTOS DE RESCISO COMPLEMENTAR FORA DO MES: TABELA R046VER E CONSIDERAR SOMENTE OS EVENTOS DO DEPARA NO INDICADOS COM FOLHA "FER"                   */
/*                      CONSIDERAR SOMENTE DEMITIDOS E OS EVENTOS CALCULADOS POSTERIOR AO MES DA RESCISO E COM TIPO DO CALCULO 11                        */
/*========================================================================================================================================================*/
SELECT VA.NUMEMP,
       CASE WHEN VA.NUMEMP = 1 THEN 304
		    WHEN VA.NUMEMP = 2 THEN 303
		    ELSE 0
	   END AS EMPRESA_LG,
       VA.TIPCOL,
	   VA.NUMCAD,
	   DBO.FNC_DEPARA( CAST(FUN.NUMEMP AS VARCHAR)+'_'+CAST(FUN.TIPCOL AS VARCHAR)+'_'+CAST(FUN.NUMCAD AS VARCHAR),'MATRICULA','HMC-IMC-SJRP') AS MATRICULA,
	   MIG.DATAFA AS DATREC,
	   CA.PERREF AS DATA_REFER,
	   REPLACE(RIGHT(CONVERT(VARCHAR,CA.PERREF,103),7),'/','') AS REFER,
	   CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,CA.PERREF,112),6)) AS REFER_NUM,
	   CA.CODCAL,
	   CA.TIPCAL,
	   TC.DESCRICAO AS DESC_TIPCAL,
	   VA.TABEVE,
	   VA.CODEVE,
	   EV.DESEVE,
	   EV.TIPEVE,
	   CASE EV.TIPEVE WHEN 1 THEN 'PROVENTO'
			          WHEN 2 THEN 'VANTAGEM'
			          WHEN 3 THEN 'DESCONTO'
			          WHEN 4 THEN 'OUTROS'
			          WHEN 5 THEN 'OUTROS ENV. PROVENTO'
			          WHEN 6 THEN 'OUTROS ENV. DESCONTO'
	   END AS DESC_TIPEVE,
	   VA.REFEVE,
	   VA.VALEVE,
	   DPE.COD_EVENTO_DE,
	   DPE.TIPO_EVENTO_DE,
	   DPE.COD_FOLHA_DE,
	   DPE.COD_EVENTO_LG,
	   DPE.EVENTO_LG AS EVENTO_LG_DEPARA,
	   EVLG.EVENTO AS EVENTO_LG,
	   DPE.TIPO_EVENTO_LG AS TIPO_EVENTO_LG_DEPARA,
	   EVLG.CODIGO_TIPO_EVENTO,
       EVLG.TIPO_EVENTO,
	   8 AS COD_FOLHA_LG,
	   'RESCISAO COMP FORA DO MES' AS DESC_FOLHA_LG,
	   DPE.COD_EVENTO_REFER_LG,
	   DPE.EVENTO_REFER_LG,
	   DPE.COD_REGRA_EVE_REFER,
	   DPE.APLIC_REGRA_EVE_REFER
  FROM R046VER VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R044CAL CA --> TABELA DE CALCULOS PROCESSADOS NA SENIOR
	   ON (CA.NUMEMP = VA.NUMEMP AND CA.CODCAL = VA.CODCAL AND CA.TIPCAL = 11) --> CONSIDERAR SOMENTE FOLHA MENSAL NO MES DE RESCISO
	   INNER JOIN TIPOCALCULO_SENIOR TC --> TABELA AUXILIAR COM OS TIPOS DE CALCULOS DA SENIOR
	   ON (TC.CODIGO = CA.tipcal)
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP=MIG.NUMEMP AND FUN.TIPCOL=MIG.TIPCOL AND FUN.NUMCAD=MIG.NUMCAD AND MIG.SITAFA = 7) --> SOMENTE DEMITIDOS 
	   INNER JOIN R008EVC EV --> TABELA SENIOR COM DE CADASTRO DE EVENTOS
	   ON (EV.CODEVE = VA.CODEVE)
	   INNER JOIN DEPARA_EVENTOS_ATUAL DPE --> TABELA DE DEPARA DE EVENTOS
	   ON (DPE.COD_EVENTO_DE = VA.CODEVE AND DPE.COD_FOLHA_DE <> 'FER' AND DPE.COD_FOLHA_LG IN (0,5))
	   INNER JOIN EVENTOS_LG EVLG --> TABELA AUXILIAR COM OS EVENTOS CADASTRADOS NA BASE DA LG
	   ON (EVLG.CODIGO_EVENTO = DPE.COD_EVENTO_LG)
 WHERE CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,CA.PERREF,112),6)) > CONVERT(BIGINT,RIGHT(MIG.DATAFA,4) + SUBSTRING(MIG.DATAFA,4,2))
   --AND VA.NUMEMP = 1 AND VA.NUMCAD = 8831 
/*========================================================================================================================================================*/
UNION ALL
/*========================================================================================================================================================*/
/* EVENTOS DEMAIS FOLHAS: TABELA R046VER E CONSIDERAR SOMENTE OS EVENTOS DO DEPARA NO INDICADOS COM FOLHA "FER"                                          */
/*                        CONSIDERAR SOMENTE EVENTOS CALCULADOS IGUAL OU ANTERIOR AO MES DA RESCISO E COM TIPOS DO CALCULO DIF DE 11, 13, 14, 15 E 93    */
/*========================================================================================================================================================*/
SELECT VA.NUMEMP,
       CASE WHEN VA.NUMEMP = 1 THEN 304
		    WHEN VA.NUMEMP = 2 THEN 303
		    ELSE 0
	   END AS EMPRESA_LG,
       VA.TIPCOL,
	   VA.NUMCAD,
	   DBO.FNC_DEPARA( CAST(FUN.NUMEMP AS VARCHAR)+'_'+CAST(FUN.TIPCOL AS VARCHAR)+'_'+CAST(FUN.NUMCAD AS VARCHAR),'MATRICULA','HMC-IMC-SJRP') AS MATRICULA,
	   MIG.DATAFA AS DATREC,
	   CA.PERREF AS DATA_REFER,
	   REPLACE(RIGHT(CONVERT(VARCHAR,CA.PERREF,103),7),'/','') AS REFER,
	   CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,CA.PERREF,112),6)) AS REFER_NUM,
	   CA.CODCAL,
	   CA.TIPCAL,
	   TC.DESCRICAO AS DESC_TIPCAL,
	   VA.TABEVE,
	   VA.CODEVE,
	   EV.DESEVE,
	   EV.TIPEVE,
	   CASE EV.TIPEVE WHEN 1 THEN 'PROVENTO'
			          WHEN 2 THEN 'VANTAGEM'
			          WHEN 3 THEN 'DESCONTO'
			          WHEN 4 THEN 'OUTROS'
			          WHEN 5 THEN 'OUTROS ENV. PROVENTO'
			          WHEN 6 THEN 'OUTROS ENV. DESCONTO'
	   END AS DESC_TIPEVE,
	   VA.REFEVE,
	   VA.VALEVE,
	   DPE.COD_EVENTO_DE,
	   DPE.TIPO_EVENTO_DE,
	   DPE.COD_FOLHA_DE,
	   DPE.COD_EVENTO_LG,
	   DPE.EVENTO_LG AS EVENTO_LG_DEPARA,
	   EVLG.EVENTO AS EVENTO_LG,
	   DPE.TIPO_EVENTO_LG AS TIPO_EVENTO_LG_DEPARA,
	   EVLG.CODIGO_TIPO_EVENTO,
       EVLG.TIPO_EVENTO,
	   DPF.COD_FOLHA_LG AS COD_FOLHA_LG,
	   DPF.DESC_FOLHA_LG,
	   DPE.COD_EVENTO_REFER_LG,
	   DPE.EVENTO_REFER_LG,
	   DPE.COD_REGRA_EVE_REFER,
	   DPE.APLIC_REGRA_EVE_REFER
  FROM R046VER VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R044CAL CA --> TABELA DE CALCULOS PROCESSADOS NA SENIOR
	   ON (CA.NUMEMP = VA.NUMEMP AND CA.CODCAL = VA.CODCAL AND CA.TIPCAL NOT IN (11,13,14,15,93)) --> CONSIDERAR SOMENTE FOLHA MENSAL NO MES DE RESCISO
	   INNER JOIN TIPOCALCULO_SENIOR TC --> TABELA AUXILIAR COM OS TIPOS DE CALCULOS DA SENIOR
	   ON (TC.CODIGO = CA.tipcal)
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP=MIG.NUMEMP AND FUN.TIPCOL=MIG.TIPCOL AND FUN.NUMCAD=MIG.NUMCAD AND MIG.SITAFA = 7) --> SOMENTE DEMITIDOS 
	   INNER JOIN R008EVC EV --> TABELA SENIOR COM DE CADASTRO DE EVENTOS
	   ON (EV.CODEVE = VA.CODEVE)
	   INNER JOIN DEPARA_EVENTOS_ATUAL DPE --> TABELA DE DEPARA DE EVENTOS
	   ON (DPE.COD_EVENTO_DE = VA.CODEVE AND DPE.COD_FOLHA_DE <> 'FER' AND DPE.COD_FOLHA_LG IN (0,1))
	   INNER JOIN EVENTOS_LG EVLG --> TABELA AUXILIAR COM OS EVENTOS CADASTRADOS NA BASE DA LG
	   ON (EVLG.CODIGO_EVENTO = DPE.COD_EVENTO_LG)
	   INNER JOIN DEPARA_FOLHA_SENIOR DPF --> TABELA DE DEPARA DE FOLHA
	   ON (DPF.COD_FOLHA_SENIOR = CA.tipcal)
 WHERE ((MIG.SITAFA <> 7) OR (MIG.SITAFA = 7 AND CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,CA.PERREF,112),6)) <= CONVERT(BIGINT,RIGHT(MIG.DATAFA,4) + SUBSTRING(MIG.DATAFA,4,2))))
   --AND VA.NUMEMP = 1 AND VA.NUMCAD = 8831 
/*========================================================================================================================================================*/
UNION ALL
/*========================================================================================================================================================*/
/* EVENTOS FOLHA MENSAL: TABELA R046VER E CONSIDERAR SOMENTE OS EVENTOS DO DEPARA NO INDICADOS COM FOLHA "FER"                                           */
/*                       CONSIDERAR SOMENTE EVENTOS CALCULADOS ANTERIOR AO MES DA RESCISO E COM TIPOS DO CALCULO IGUAL A 11, 13, 14, 15 E 93             */
/*========================================================================================================================================================*/
SELECT VA.NUMEMP,
       CASE WHEN VA.NUMEMP = 1 THEN 304
		    WHEN VA.NUMEMP = 2 THEN 303
		    ELSE 0
	   END AS EMPRESA_LG,
       VA.TIPCOL,
	   VA.NUMCAD,
	   DBO.FNC_DEPARA( CAST(FUN.NUMEMP AS VARCHAR)+'_'+CAST(FUN.TIPCOL AS VARCHAR)+'_'+CAST(FUN.NUMCAD AS VARCHAR),'MATRICULA','HMC-IMC-SJRP') AS MATRICULA,
	   MIG.DATAFA AS DATREC,
	   CA.PERREF AS DATA_REFER,
	   REPLACE(RIGHT(CONVERT(VARCHAR,CA.PERREF,103),7),'/','') AS REFER,
	   CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,CA.PERREF,112),6)) AS REFER_NUM,
	   CA.CODCAL,
	   CA.TIPCAL,
	   TC.DESCRICAO AS DESC_TIPCAL,
	   VA.TABEVE,
	   VA.CODEVE,
	   EV.DESEVE,
	   EV.TIPEVE,
	   CASE EV.TIPEVE WHEN 1 THEN 'PROVENTO'
			          WHEN 2 THEN 'VANTAGEM'
			          WHEN 3 THEN 'DESCONTO'
			          WHEN 4 THEN 'OUTROS'
			          WHEN 5 THEN 'OUTROS ENV. PROVENTO'
			          WHEN 6 THEN 'OUTROS ENV. DESCONTO'
	   END AS DESC_TIPEVE,
	   VA.REFEVE,
	   VA.VALEVE,
	   DPE.COD_EVENTO_DE,
	   DPE.TIPO_EVENTO_DE,
	   DPE.COD_FOLHA_DE,
	   DPE.COD_EVENTO_LG,
	   DPE.EVENTO_LG AS EVENTO_LG_DEPARA,
	   EVLG.EVENTO AS EVENTO_LG,
	   DPE.TIPO_EVENTO_LG AS TIPO_EVENTO_LG_DEPARA,
	   EVLG.CODIGO_TIPO_EVENTO,
       EVLG.TIPO_EVENTO,
	   DPF.COD_FOLHA_LG AS COD_FOLHA_LG,
	   DPF.DESC_FOLHA_LG,
	   DPE.COD_EVENTO_REFER_LG,
	   DPE.EVENTO_REFER_LG,
	   DPE.COD_REGRA_EVE_REFER,
	   DPE.APLIC_REGRA_EVE_REFER
  FROM R046VER VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R044CAL CA --> TABELA DE CALCULOS PROCESSADOS NA SENIOR
	   ON (CA.NUMEMP = VA.NUMEMP AND CA.CODCAL = VA.CODCAL AND CA.TIPCAL IN (11,13,14,15,93)) --> CONSIDERAR SOMENTE FOLHA MENSAL NO MES DE RESCISO
	   INNER JOIN TIPOCALCULO_SENIOR TC --> TABELA AUXILIAR COM OS TIPOS DE CALCULOS DA SENIOR
	   ON (TC.CODIGO = CA.tipcal)
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP=MIG.NUMEMP AND FUN.TIPCOL=MIG.TIPCOL AND FUN.NUMCAD=MIG.NUMCAD AND MIG.SITAFA = 7) --> SOMENTE DEMITIDOS 
	   INNER JOIN R008EVC EV --> TABELA SENIOR COM DE CADASTRO DE EVENTOS
	   ON (EV.CODEVE = VA.CODEVE)
	   INNER JOIN DEPARA_EVENTOS_ATUAL DPE --> TABELA DE DEPARA DE EVENTOS
	   ON (DPE.COD_EVENTO_DE = VA.CODEVE AND DPE.COD_FOLHA_DE <> 'FER' AND DPE.COD_FOLHA_LG IN (0,1))
	   INNER JOIN EVENTOS_LG EVLG --> TABELA AUXILIAR COM OS EVENTOS CADASTRADOS NA BASE DA LG
	   ON (EVLG.CODIGO_EVENTO = DPE.COD_EVENTO_LG)
	   INNER JOIN DEPARA_FOLHA_SENIOR DPF --> TABELA DE DEPARA DE FOLHA
	   ON (DPF.COD_FOLHA_SENIOR = CA.tipcal)
 WHERE ((MIG.SITAFA <> 7) OR (MIG.SITAFA = 7 AND CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,CA.PERREF,112),6)) < CONVERT(BIGINT,RIGHT(MIG.DATAFA,4) + SUBSTRING(MIG.DATAFA,4,2))))
   --AND VA.NUMEMP = 1 AND VA.NUMCAD = 8684 AND CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,CA.PERREF,112),6)) = 202205
/*========================================================================================================================================================*/
 ORDER BY REFER_NUM DESC, NUMEMP, NUMCAD, COD_FOLHA_LG, TIPCAL, TIPEVE, CODEVE
/*========================================================================================================================================================*/

/*
SELECT NUMCAD, REFER_NUM, CODCAL, TIPCAL, DESC_TIPCAL, CODEVE, DESEVE, TIPEVE, DESC_TIPEVE, REFEVE, VALEVE, COD_EVENTO_LG, EVENTO_LG, CODIGO_TIPO_EVENTO, TIPO_EVENTO
  FROM VW_FICHA_FINANCEIRA_SENIOR FF
 ORDER BY REFER_NUM DESC, NUMEMP, NUMCAD, COD_FOLHA_LG, TIPCAL, TIPEVE, CODEVE
*/





--> SCRIPT PARA AGRUPAR OS VALORES DE ACORDO COM O LAYOUT DA LG (VALORES HISTORICOS) - JA TRATANDO EVENTOS DE VALORES E EVENTOS DE REFERNCIA
--> E INSRINDO O RESULTADO NA TABELA "VALORESHISTORICOS" PARA A GERAO DO LAYOUT FINAL DE IMPORTAO
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
/*
SELECT *
  INTO VALORESHISTORICOS_VX
  FROM VALORESHISTORICOS
*/

-- DROP TABLE [VALORESHISTORICOS]
-- TRUNCATE TABLE [VALORESHISTORICOS]
CREATE TABLE [dbo].[VALORESHISTORICOS](
	[CODIGO_EMPRESA]		[int] NOT NULL,
	[MATRICULA]				[bigint] NOT NULL,
	[COD_FOLHA_LG]			[int] NOT NULL,
	[REFERENCIA]			[varchar](502) NOT NULL,
	[PerComp_Aux]			[bigint] NOT NULL,
	[COD_EVENTO_LG]			[bigint] NOT NULL,
	[CODIGO_TIPO_EVENTO]	[varchar](500) NOT NULL,
	[TIPO_EVENTO]			[varchar](500) NOT NULL,
	[Vlr_Evento_NUM]		[numeric](38, 2) NOT NULL
) ON [PRIMARY]


CREATE UNIQUE INDEX IDX_VALORESHISTORICOS_01 ON VALORESHISTORICOS ([CODIGO_EMPRESA],[MATRICULA],[PerComp_Aux],[COD_FOLHA_LG],[COD_EVENTO_LG])
CREATE INDEX IDX_VALORESHISTORICOS_02 ON VALORESHISTORICOS ([CODIGO_EMPRESA],[MATRICULA],[PerComp_Aux],[COD_FOLHA_LG])
CREATE INDEX IDX_VALORESHISTORICOS_03 ON VALORESHISTORICOS ([CODIGO_EMPRESA],[MATRICULA],[PerComp_Aux])
CREATE INDEX IDX_VALORESHISTORICOS_04 ON VALORESHISTORICOS ([CODIGO_EMPRESA],[MATRICULA])
CREATE INDEX IDX_VALORESHISTORICOS_05 ON VALORESHISTORICOS ([CODIGO_EMPRESA])
CREATE INDEX IDX_VALORESHISTORICOS_06 ON VALORESHISTORICOS ([PerComp_Aux],[COD_FOLHA_LG],[COD_EVENTO_LG])
CREATE INDEX IDX_VALORESHISTORICOS_07 ON VALORESHISTORICOS ([PerComp_Aux],[COD_FOLHA_LG])
CREATE INDEX IDX_VALORESHISTORICOS_08 ON VALORESHISTORICOS ([PerComp_Aux])
CREATE INDEX IDX_VALORESHISTORICOS_09 ON VALORESHISTORICOS ([COD_FOLHA_LG],[COD_EVENTO_LG])
CREATE INDEX IDX_VALORESHISTORICOS_10 ON VALORESHISTORICOS ([COD_FOLHA_LG])
CREATE INDEX IDX_VALORESHISTORICOS_11 ON VALORESHISTORICOS ([COD_EVENTO_LG])



INSERT INTO VALORESHISTORICOS (CODIGO_EMPRESA,MATRICULA,COD_FOLHA_LG,REFERENCIA,PerComp_Aux,COD_EVENTO_LG,CODIGO_TIPO_EVENTO,TIPO_EVENTO,Vlr_Evento_NUM)
--> AGRUPANDO OS EVENTOS DE VALORES
SELECT FF.EMPRESA_LG AS "CODIGO_EMPRESA",
       FF.MATRICULA AS MATRICULA,
	   FF.COD_FOLHA_LG,
	   FF.REFER AS REFERENCIA,
	   FF.REFER_NUM,
	   FF.COD_EVENTO_LG,
	   FF.CODIGO_TIPO_EVENTO,
	   FF.TIPO_EVENTO,
	   SUM(FF.VALEVE) AS VALOREVENTO
  FROM VW_FICHA_FINANCEIRA_SENIOR FF
 WHERE FF.VALEVE > 0
   AND NOT EXISTS (SELECT 1
                     FROM VALORESHISTORICOS VA
					WHERE VA.CODIGO_EMPRESA = FF.EMPRESA_LG
					  AND VA.MATRICULA = FF.MATRICULA
					  AND VA.PerComp_Aux = FF.REFER_NUM
					  AND VA.COD_FOLHA_LG = FF.COD_FOLHA_LG)
   --AND FF.COD_FOLHA_LG = 4
 GROUP BY FF.EMPRESA_LG,
          FF.MATRICULA,
	      FF.COD_FOLHA_LG,
	      FF.REFER,
		  FF.REFER_NUM,
	      FF.COD_EVENTO_LG,
		  FF.CODIGO_TIPO_EVENTO,
	      FF.TIPO_EVENTO
HAVING SUM(FF.VALEVE) > 0
UNION ALL
--> AGRUPANDO OS EVENTOS DE REFERNCIA (JA COM A REGRA APLICADA)
SELECT FF.EMPRESA_LG AS "CODIGO_EMPRESA",
       FF.MATRICULA AS MATRICULA,
	   FF.COD_FOLHA_LG,
	   FF.REFER AS REFERENCIA,
	   FF.REFER_NUM,
	   FF.COD_EVENTO_REFER_LG AS COD_EVENTO_LG,
	   2 AS CODIGO_TIPO_EVENTO,
	   'Resultado' AS TIPO_EVENTO,
	   SUM(FF.REFEVE) AS BASEEVENTO_NUM_
  FROM VW_FICHA_FINANCEIRA_SENIOR FF
 WHERE FF.COD_EVENTO_REFER_LG > 0
   AND FF.REFEVE > 0
   AND NOT EXISTS (SELECT 1
                     FROM VALORESHISTORICOS VA
					WHERE VA.CODIGO_EMPRESA = FF.EMPRESA_LG
					  AND VA.MATRICULA = FF.MATRICULA
					  AND VA.PerComp_Aux = FF.REFER_NUM
					  AND VA.COD_FOLHA_LG = FF.COD_FOLHA_LG)
   --AND FF.COD_FOLHA_LG = 4
 GROUP BY FF.EMPRESA_LG,
          FF.MATRICULA,
	      FF.COD_FOLHA_LG,
	      FF.REFER,
		  FF.REFER_NUM,
	      FF.COD_EVENTO_REFER_LG
HAVING SUM(FF.REFEVE) > 0





