/**********************************************************************************************************************/
/********** PROJETO GHC - BASE SENIOR - SJRP - 2022 *******************************************************************/
/********** MIGRAO DE FICHA FINANCEIRA ******************************************************************************/
/**********************************************************************************************************************/
/* SCRIPT 03 - MIGRAO DOS TORAIS DE PROVENTOS, DESCONTOS E LIQUIDO                                                  */
/**********************************************************************************************************************/
/* SOMENTE NUMEMP 1 E 2                                                                                               */
/**********************************************************************************************************************/



--> SCRIPT PARA CRIAR O EVENTO DE TOTAL DE PROVENTOS (NO EXISTE NO DEPARA)
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
INSERT INTO VALORESHISTORICOS (CODIGO_EMPRESA,MATRICULA,COD_FOLHA_LG,REFERENCIA,PerComp_Aux,COD_EVENTO_LG,CODIGO_TIPO_EVENTO,TIPO_EVENTO,Vlr_Evento_NUM)
SELECT VA.CODIGO_EMPRESA,
	   VA.MATRICULA,
	   VA.COD_FOLHA_LG,
	   VA.REFERENCIA,
	   VA.PerComp_Aux,
	   10000 AS COD_EVENTO_LG,
	   2 AS CODIGO_TIPO_EVENTO,
	   'Resultado' AS TIPO_EVENTO,
	   SUM(VA.Vlr_Evento_NUM) AS VALOR
  FROM VALORESHISTORICOS VA
 WHERE VA.PerComp_Aux BETWEEN 190001 AND 202208
   AND CODIGO_TIPO_EVENTO = 0
   AND VA.COD_FOLHA_LG NOT IN (32,33)
   --AND VA.CODIGO_EMPRESA = 303 AND VA.MATRICULA = 181 AND VA.COD_FOLHA_LG = 5 AND VA.PerComp_Aux = 202208
   AND NOT EXISTS (SELECT 1
                     FROM VALORESHISTORICOS VA10000
					WHERE VA10000.CODIGO_EMPRESA = VA.CODIGO_EMPRESA
					  AND VA10000.MATRICULA = VA.MATRICULA
					  AND VA10000.PerComp_Aux = VA.PerComp_Aux
					  AND VA10000.COD_FOLHA_LG = VA.COD_FOLHA_LG
					  AND VA10000.COD_EVENTO_LG = 10000)
 GROUP BY VA.CODIGO_EMPRESA,
	      VA.MATRICULA,
	      VA.COD_FOLHA_LG,
	      VA.REFERENCIA,
		  VA.PerComp_Aux
 ORDER BY VA.CODIGO_EMPRESA,
	      VA.MATRICULA,
		  VA.PerComp_Aux,
	      VA.COD_FOLHA_LG



--> SCRIPT PARA CRIAR O EVENTO DE TOTAL DE DESCONTOS (NO EXISTE NO DEPARA)
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
INSERT INTO VALORESHISTORICOS (CODIGO_EMPRESA,MATRICULA,COD_FOLHA_LG,REFERENCIA,PerComp_Aux,COD_EVENTO_LG,CODIGO_TIPO_EVENTO,TIPO_EVENTO,Vlr_Evento_NUM)
SELECT VA.CODIGO_EMPRESA,
	   VA.MATRICULA,
	   VA.COD_FOLHA_LG,
	   VA.REFERENCIA,
	   VA.PerComp_Aux,
	   10100 AS COD_EVENTO_LG,
	   2 AS CODIGO_TIPO_EVENTO,
	   'Resultado' AS TIPO_EVENTO,
	   SUM(VA.Vlr_Evento_NUM) AS VALOR
  FROM VALORESHISTORICOS VA
 WHERE VA.PerComp_Aux BETWEEN 190001 AND 202208
   AND VA.COD_FOLHA_LG NOT IN (32,33)
   AND CODIGO_TIPO_EVENTO = 1
   AND NOT EXISTS (SELECT 1
                     FROM VALORESHISTORICOS VA10100
					WHERE VA10100.CODIGO_EMPRESA = VA.CODIGO_EMPRESA
					  AND VA10100.MATRICULA = VA.MATRICULA
					  AND VA10100.PerComp_Aux = VA.PerComp_Aux
					  AND VA10100.COD_FOLHA_LG = VA.COD_FOLHA_LG
					  AND VA10100.COD_EVENTO_LG = 10100)
 GROUP BY VA.CODIGO_EMPRESA,
	      VA.MATRICULA,
	      VA.COD_FOLHA_LG,
	      VA.REFERENCIA,
		  VA.PerComp_Aux
 ORDER BY VA.CODIGO_EMPRESA,
	      VA.MATRICULA,
		  VA.PerComp_Aux,
	      VA.COD_FOLHA_LG



--> SCRIPT PARA CRIAR O EVENTO DE TOTAL LIQUIDO (SOMENTE APOS A VALIDAO DOS TOTAIS E PARA QUEM NAO POSSUI NA BASE LEGADA)
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
INSERT INTO VALORESHISTORICOS (CODIGO_EMPRESA,MATRICULA,COD_FOLHA_LG,REFERENCIA,PerComp_Aux,COD_EVENTO_LG,CODIGO_TIPO_EVENTO,TIPO_EVENTO,Vlr_Evento_NUM)
SELECT VA.CODIGO_EMPRESA,
	   VA.MATRICULA,
	   VA.COD_FOLHA_LG,
	   VA.REFERENCIA,
	   VA.PerComp_Aux,
	   10200 AS COD_EVENTO_LG,
	   2 AS CODIGO_TIPO_EVENTO,
	   'Resultado' AS TIPO_EVENTO,
	   --ISNULL(VA_PROV.Vlr_Evento_NUM,0) AS Vlr_Evento_PROV, ISNULL(VA_DESC.Vlr_Evento_NUM,0) AS Vlr_Evento_DESC,
	   ISNULL(VA_PROV.Vlr_Evento_NUM,0) - ISNULL(VA_DESC.Vlr_Evento_NUM,0) AS Vlr_Evento
  FROM VALORESHISTORICOS VA
       LEFT OUTER JOIN VALORESHISTORICOS VA_PROV
	   ON (VA_PROV.CODIGO_EMPRESA = VA.CODIGO_EMPRESA AND
	       VA_PROV.MATRICULA = VA.MATRICULA AND
		   VA_PROV.COD_FOLHA_LG = VA.COD_FOLHA_LG AND
		   VA_PROV.PerComp_Aux = VA.PerComp_Aux AND
		   VA_PROV.COD_EVENTO_LG = 10000)
	   LEFT OUTER JOIN VALORESHISTORICOS VA_DESC
	   ON (VA_DESC.CODIGO_EMPRESA = VA.CODIGO_EMPRESA AND
	       VA_DESC.MATRICULA = VA.MATRICULA AND
		   VA_DESC.COD_FOLHA_LG = VA.COD_FOLHA_LG AND
		   VA_DESC.PerComp_Aux = VA.PerComp_Aux AND
		   VA_DESC.COD_EVENTO_LG = 10100)
 WHERE VA.PerComp_Aux BETWEEN 190001 AND 202208
   AND VA.COD_FOLHA_LG NOT IN (32,33)
   AND ISNULL(VA_PROV.Vlr_Evento_NUM,0) - ISNULL(VA_DESC.Vlr_Evento_NUM,0) > 0
   AND NOT EXISTS (SELECT 1
                     FROM VALORESHISTORICOS VA10000
					WHERE VA10000.CODIGO_EMPRESA = VA.CODIGO_EMPRESA
					  AND VA10000.MATRICULA = VA.MATRICULA
					  AND VA10000.PerComp_Aux = VA.PerComp_Aux
					  AND VA10000.COD_FOLHA_LG = VA.COD_FOLHA_LG
					  AND VA10000.COD_EVENTO_LG = 10200)
 GROUP BY VA.CODIGO_EMPRESA,
	      VA.MATRICULA,
	      VA.COD_FOLHA_LG,
	      VA.REFERENCIA,
		  VA.PerComp_Aux,
		  ISNULL(VA_PROV.Vlr_Evento_NUM,0),
		  ISNULL(VA_DESC.Vlr_Evento_NUM,0)
 ORDER BY VA.CODIGO_EMPRESA,
	      VA.MATRICULA,
		  VA.PerComp_Aux,
	      VA.COD_FOLHA_LG


--> VALIDANDO O LIQUIDO MIGRADO A PARTIR DOS EVENTOS DE TOTAIS
--  SOMENTE  VALIDO EXECUTAR QUANDO O LIQUIDO DAS FOLHAS  MIGRADO DA BASE LEGADA, OU OS TOTAIS DE PROVENTOS E DESCONTOS
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
SELECT DISTINCT
       V.CODIGO_EMPRESA,
       V.COD_FOLHA_LG,
       V.MATRICULA,
	   V.PerComp_Aux,
	   V.COD_EVENTO_LG,
	   V.Vlr_Evento_NUM AS LIQUIDO_MIG_ADP,
	   ISNULL(PROVENTO.Vlr_Evento_NUM,0) AS PROVENTO_CALC,
	   ISNULL(DESCONTO.Vlr_Evento_NUM,0) AS DESCONTO_CALC,
	   ROUND(ISNULL(PROVENTO.Vlr_Evento_NUM,0) - ISNULL(DESCONTO.Vlr_Evento_NUM,0),2) AS LIQUIDO_CALC
  INTO TB_DIFERENCA_LIQUIDO_10220_20221107 /* DROP TABLE TB_DIFERENCA_LIQUIDO_2019_2021_20220531 */
  FROM VALORESHISTORICOS V
       LEFT OUTER JOIN VALORESHISTORICOS PROVENTO
	   ON (PROVENTO.CODIGO_EMPRESA = V.CODIGO_EMPRESA AND
	       PROVENTO.COD_FOLHA_LG = V.COD_FOLHA_LG AND
		   PROVENTO.MATRICULA = V.MATRICULA AND
		   PROVENTO.PerComp_Aux = V.PerComp_Aux AND
		   PROVENTO.COD_EVENTO_LG = 10000)
	   LEFT OUTER JOIN VALORESHISTORICOS DESCONTO
	   ON (DESCONTO.CODIGO_EMPRESA = V.CODIGO_EMPRESA AND
	       DESCONTO.COD_FOLHA_LG = V.COD_FOLHA_LG AND
		   DESCONTO.MATRICULA = V.MATRICULA AND
		   DESCONTO.PerComp_Aux = V.PerComp_Aux AND
		   DESCONTO.COD_EVENTO_LG = 10100)
 WHERE V.COD_EVENTO_LG = 10220
   AND V.Vlr_Evento_NUM <> ROUND(ISNULL(PROVENTO.Vlr_Evento_NUM,0) - ISNULL(DESCONTO.Vlr_Evento_NUM,0),2)
   --AND ((ISNULL(PROVENTO.Vlr_Evento_NUM,0) > 0) AND (ISNULL(DESCONTO.Vlr_Evento_NUM,0) > 0) AND (ISNULL(PROVENTO.Vlr_Evento_NUM,0) <> ISNULL(DESCONTO.Vlr_Evento_NUM,0)))
   AND V.PerComp_Aux BETWEEN 190001 AND 202209
   AND V.COD_FOLHA_LG NOT IN (32,33)
   --AND V.VAMATFUNC = 71336
 ORDER BY 4 DESC,1,3,2




--> VALIDANDO O LIQUIDO MIGRADO A PARTIR DOS EVENTOS DE TOTAIS, SOMENTE VERIFICANDO OS LIQUIDOS ZERADOS OU MENORES QUE ZERO
--  SOMENTE  VALIDO EXECUTAR QUANDO O LIQUIDO DAS FOLHAS E OS TOTAIS DE PROVENTOS E DESCONTOS NO SO  MIGRADOS DA BASE LEGADA
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- DROP TABLE TB_DIFERENCA_LIQUIDO_20221107
SELECT V.CODIGO_EMPRESA,
       V.COD_FOLHA_LG,
       V.MATRICULA,
	   V.PerComp_Aux,
	   ISNULL(PROVENTO.Vlr_Evento_NUM,0) AS PROVENTO_CALC,
	   ISNULL(DESCONTO.Vlr_Evento_NUM,0) AS DESCONTO_CALC,
	   ROUND(ISNULL(PROVENTO.Vlr_Evento_NUM,0) - ISNULL(DESCONTO.Vlr_Evento_NUM,0),2) AS LIQUIDO_CALC
  --INTO TB_DIFERENCA_LIQUIDO_20221107
  FROM VALORESHISTORICOS V
       LEFT OUTER JOIN VALORESHISTORICOS PROVENTO
	   ON (PROVENTO.CODIGO_EMPRESA = V.CODIGO_EMPRESA AND
	       PROVENTO.COD_FOLHA_LG = V.COD_FOLHA_LG AND
		   PROVENTO.MATRICULA = V.MATRICULA AND
		   PROVENTO.PerComp_Aux = V.PerComp_Aux AND
		   PROVENTO.COD_EVENTO_LG = 10000)
	   LEFT OUTER JOIN VALORESHISTORICOS DESCONTO
	   ON (DESCONTO.CODIGO_EMPRESA = V.CODIGO_EMPRESA AND
	       DESCONTO.COD_FOLHA_LG = V.COD_FOLHA_LG AND
		   DESCONTO.MATRICULA = V.MATRICULA AND
		   DESCONTO.PerComp_Aux = V.PerComp_Aux AND
		   DESCONTO.COD_EVENTO_LG = 10100)
 WHERE ROUND(ISNULL(PROVENTO.Vlr_Evento_NUM,0) - ISNULL(DESCONTO.Vlr_Evento_NUM,0),2) < 0
 GROUP BY V.CODIGO_EMPRESA, V.COD_FOLHA_LG, V.MATRICULA, V.PerComp_Aux, ISNULL(PROVENTO.Vlr_Evento_NUM,0), ISNULL(DESCONTO.Vlr_Evento_NUM,0)




 --> GERANDO O LAYOUT DE IMPORTAO APS TODOS OS PERODOS PROCESSADOS
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
SELECT '1'					AS "01 Quando o registro existir",
       VA.CODIGO_EMPRESA	AS "02 Cdigo da Empresa",
	   VA.MATRICULA			AS "03 Matrcula do colaborador",
	   VA.COD_FOLHA_LG		AS "04 Cdigo da folha",
	   VA.REFERENCIA		AS "05 Ms de Referncia",
	   VA.COD_EVENTO_LG		AS "06 Cdigo do Evento",
	   ''					AS "07 Total das parcelas",
	   ''					AS "08 N da parcela atual",
	   VA.Vlr_Evento_NUM	AS "09 Valor"
  FROM VALORESHISTORICOS VA
 WHERE VA.PerComp_Aux BETWEEN 201701 AND 202301
   AND VA.Vlr_Evento_NUM > 0
   --and VA.COD_FOLHA_LG = 10
 ORDER BY VA.PerComp_Aux DESC, CONVERT(BIGINT,VA.CODIGO_EMPRESA), CONVERT(BIGINT,VA.MATRICULA), CONVERT(BIGINT,VA.COD_FOLHA_LG), CONVERT(BIGINT,VA.COD_EVENTO_LG)




SELECT '2'					AS "01 Quando o registro existir",
       VA.CODIGO_EMPRESA	AS "02 Cdigo da Empresa",
	   VA.MATRICULA			AS "03 Matrcula do colaborador",
	   VA.COD_FOLHA_LG		AS "04 Cdigo da folha",
	   VA.REFERENCIA		AS "05 Ms de Referncia",
	   VA.COD_EVENTO_LG		AS "06 Cdigo do Evento",
	   ''					AS "07 Total das parcelas",
	   ''					AS "08 N da parcela atual",
	   VA.Vlr_Evento_NUM	AS "09 Valor"
  FROM VALORESHISTORICOS VA
 WHERE VA.PerComp_Aux BETWEEN 202001 AND 202112
   AND VA.Vlr_Evento_NUM > 0
   AND VA.COD_EVENTO_LG IN (SELECT R.COD_EVENTO_REFER_LG FROM TB_AUX_EVENTO_REFER_LG R)
 ORDER BY VA.PerComp_Aux DESC, CONVERT(BIGINT,VA.CODIGO_EMPRESA), CONVERT(BIGINT,VA.MATRICULA), CONVERT(BIGINT,VA.COD_FOLHA_LG), CONVERT(BIGINT,VA.COD_EVENTO_LG)