/**********************************************************************************************************************/
/********** PROJETO GHC - BASE SENIOR - SJRP - 2022 *******************************************************************/
/********** MIGRAO DE FICHA FINANCEIRA ******************************************************************************/
/**********************************************************************************************************************/
/* SCRIPT 04 - MIGRAO DAS PROVISES A PARTIR DAS TABELAS ESPECIFICAS                                                */
/**********************************************************************************************************************/
/* SOMENTE NUMEMP 1 E 2                                                                                               */
/**********************************************************************************************************************/


ALTER VIEW VW_FICHA_FINANCEIRA_SENIOR_PROVISAO AS
--======================================================================================================================
--> FOLHA 32
--======================================================================================================================
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15010 - PF-PROVISAO MES 1/3 FERIAS
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: prvmes
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 2 e o valor for positivo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15010 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.PRVMES AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
  WHERE VA.TIPPRV = 1
    AND VA.TIPVAL = 2
    AND VA.PRVMES > 0
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15015 - PF-PROVISAO MES FERIAS TOTAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: prvmes
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 1 e o valor for positivo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15015 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.PRVMES AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 1
   AND VA.PRVMES > 0
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15020 - PF-PROVISAO MES INSS FERIAS
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: prvmes
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 3 e o valor for positivo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15020 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.PRVMES AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 3
   AND VA.PRVMES > 0
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15025 - PF-PROVISAO MES FGTS FERIAS
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: prvmes
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 4 e o valor for positivo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15025 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.PRVMES AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 4
   AND VA.PRVMES > 0
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15055 - PF-BAIXA MES FERIAS TOTAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: prvmes
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 1 e o valor for negativo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15055 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.PRVMES * (-1) AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 1
   AND VA.PRVMES < 0
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15060 - PF-BAIXA MES INSS FERIAS
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: prvmes
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 3 e o valor for negativo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15060 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.PRVMES * (-1) AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 3
   AND VA.PRVMES < 0
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15065 - PF-BAIXA MES FGTS FERIAS
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: prvmes
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 4 e o valor for negativo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15065 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.PRVMES * (-1) AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 4
   AND VA.PRVMES < 0
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 24056 - PF-BAIXA 1/3 FERIAS MES
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: prvmes
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 2 e o valor for negativo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   24056 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.PRVMES * (-1) AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 2
   AND VA.PRVMES < 0
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15160 - PF-PROVISAO AJUSTE POS FERIAS PARTE FIXA
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: ajuprv
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 1 e o valor for positivo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15160 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.AJUPRV AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 1
   AND VA.AJUPRV > 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15165 - PF-PROVISAO AJUSTE POS FERIAS PARTE VAR
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: ajuprv
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 1 e o valor for positivo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15165 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.AJUPRV AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 1
   AND VA.AJUPRV > 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15170 - PF-PROVISAO AJUSTE POS 1/3 FERIAS
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: ajuprv
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 2 e o valor for positivo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15170 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.AJUPRV AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 2
   AND VA.AJUPRV > 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15175 - PF-PROVISAO AJUSTE POS FERIAS TOTAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: ajuprv
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 1 e o valor for positivo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15175 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.AJUPRV AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 1
   AND VA.AJUPRV > 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15180 - PF-PROVISAO AJUSTE POS INSS FERIAS
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: ajuprv
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 3 e o valor for positivo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15180 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.AJUPRV AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 3
   AND VA.AJUPRV > 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15185 - PF-PROVISAO AJUSTE POS FGTS FERIAS
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: ajuprv
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 4 e o valor for positivo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15185 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.AJUPRV AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 4
   AND VA.AJUPRV > 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15200 - PF-PROVISAO AJUSTE NEG FERIAS PARTE FIXA
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: ajuprv
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 4 e o valor for negativo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15200 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.AJUPRV * (-1) AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 4
   AND VA.AJUPRV < 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15205 - PF-PROVISAO AJUSTE NEG FERIAS PARTE VAR
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: ajuprv
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 1 e o valor for negativo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15205 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.AJUPRV * (-1) AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 1
   AND VA.AJUPRV < 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15210 - PF-PROVISAO AJUSTE NEG 1/3 FERIAS
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: ajuprv
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 2 e o valor for negativo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15210 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.AJUPRV * (-1) AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 2
   AND VA.AJUPRV < 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15215 - PF-PROVISAO AJUSTE NEG FERIAS TOTAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: ajuprv
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 1 e o valor for negativo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15215 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.AJUPRV * (-1) AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 1
   AND VA.AJUPRV < 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15220 - PF-PROVISAO AJUSTE NEG INSS FERIAS
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: ajuprv
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 3 e o valor for negativo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15220 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.AJUPRV * (-1) AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 3
   AND VA.AJUPRV < 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15225 - PF-PROVISAO AJUSTE NEG FGTS FERIAS
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: ajuprv
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 4 e o valor for negativo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15225 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.AJUPRV * (-1) AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 4
   AND VA.AJUPRV < 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15120 - PF-PROVISAO ACUM MA FERIAS PARTE FIXA
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: basprv
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 1
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15120 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.BASPRV AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 1
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15125 - PF-PROVISAO ACUM MA FERIAS PARTE VAR
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: basprv
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 1
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15125 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.BASPRV AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 1
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15130 - PF-PF-PROVISAO ACUM MA 1/3 FERIAS
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: basprv
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 4
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15130 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.BASPRV AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 4
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15135 - PF-PROVISAO ACUM MA FERIAS TOTAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: basprv
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 1
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15135 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.BASPRV AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 1
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15140 - PF-PROVISAO ACUM MA INSS FERIAS
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: basprv
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 3
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15140 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.BASPRV AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 3
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15145 - PF-PROVISAO ACUM MA FGTS FERIAS
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: basprv
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 4
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15145 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.BASPRV AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 4
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15090 - PF-PROVISAO ACUM 1/3 FERIAS
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: sldatu
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 2
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15090 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.SLDATU AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 2
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15095 - PF-PROVISAO ACUM FERIAS TOTAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: sldatu
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 1
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15095 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.SLDATU AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 1
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15100 - PF-PROVISAO ACUM INSS FERIAS
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: sldatu
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 3
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15100 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.SLDATU AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 3
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15105 - PF-PROVISAO ACUM FGTS FERIAS 
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: sldatu
Migrar quando a coluna "tipprv" for igual a 1 e a coluna "tipval" for igual a 4
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   32 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15105 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.SLDATU AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 1
   AND VA.TIPVAL = 4
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------

--======================================================================================================================
--> FOLHA 33
--======================================================================================================================

/* CMPCTD
------------------------------------------------------------------------------------------------------------------------
EVENTO 15505 - P13-PROVISAO AJUSTE N 13 SAL TOTAL GERA 
------------------------------------------------------------------------------------------------------------------------
Tabela: R054CTD  Coluna: binmes
<<Sem regra especificada>>
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, '0' AS TIPPRV, '0' AS TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.CMPCTD,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.CMPCTD,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   33 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15505 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.BINMES AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R054CTD VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15440 - P13-PROVISAO AJUSTE P 13 SAL PARTE FIXA
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: ajuprv
Migrar quando a coluna "tipprv" for igual a 2 e a coluna "tipval" for igual a 1 e o valor for positivo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   33 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15440 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.AJUPRV AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 2
   AND VA.TIPVAL = 1
   AND VA.AJUPRV > 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15445 - P13-PROVISAO AJUSTE P 13 SAL PARTE VAR
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: ajuprv
Migrar quando a coluna "tipprv" for igual a 2 e a coluna "tipval" for igual a 1 e o valor for positivo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   33 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15445 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.AJUPRV AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 2
   AND VA.TIPVAL = 1
   AND VA.AJUPRV > 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15450 - P13-PROVISAO AJUSTE P 13 SAL TOTAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: ajuprv
Migrar quando a coluna "tipprv" for igual a 2 e a coluna "tipval" for igual a 1 e o valor for positivo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   33 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15450 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.AJUPRV AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 2
   AND VA.TIPVAL = 1
   AND VA.AJUPRV > 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15455 - P13-PROVISAO AJUSTE P INSS 13 SAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: ajuprv
Migrar quando a coluna "tipprv" for igual a 2 e a coluna "tipval" for igual a 2 e o valor for positivo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   33 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15455 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.AJUPRV AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 2
   AND VA.TIPVAL = 2
   AND VA.AJUPRV > 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15460 - P13-PROVISAO AJUSTE P FGTS 13 SAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: ajuprv
Migrar quando a coluna "tipprv" for igual a 2 e a coluna "tipval" for igual a 1 e o valor for positivo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   33 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15460 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.AJUPRV AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 2
   AND VA.TIPVAL = 1
   AND VA.AJUPRV > 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15475 - P13-PROVISAO AJUSTE N 13 SAL PARTE FIXA
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: ajuprv
Migrar quando a coluna "tipprv" for igual a 2 e a coluna "tipval" for igual a 2 e o valor for negativo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   33 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15475 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.AJUPRV * (-1) AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 2
   AND VA.TIPVAL = 2
   AND VA.AJUPRV < 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15480 - P13-PROVISAO AJUSTE N 13 SAL PARTE VAR
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: ajuprv
Migrar quando a coluna "tipprv" for igual a 2 e a coluna "tipval" for igual a 2 e o valor for negativo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   33 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15480 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.AJUPRV * (-1) AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 2
   AND VA.TIPVAL = 2
   AND VA.AJUPRV < 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15485 - P13-PROVISAO AJUSTE N 13 SAL TOTAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: ajuprv
Migrar quando a coluna "tipprv" for igual a 2 e a coluna "tipval" for igual a 2 e o valor for negativo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   33 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15485 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.AJUPRV * (-1) AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 2
   AND VA.TIPVAL = 2
   AND VA.AJUPRV < 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15495 - P13-PROVISAO AJUSTE N FGTS 13 SAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: ajuprv
Migrar quando a coluna "tipprv" for igual a 2 e a coluna "tipval" for igual a 2 e o valor for negativo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   33 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15495 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.AJUPRV * (-1) AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 2
   AND VA.TIPVAL = 2
   AND VA.AJUPRV < 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15505 - P13-PROVISAO AJUSTE N 13 SAL TOTAL GERA
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: ajuprv
Migrar quando a coluna "tipprv" for igual a 2 e a coluna "tipval" for igual a 2 e o valor for negativo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   33 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15505 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.AJUPRV * (-1) AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 2
   AND VA.TIPVAL = 2
   AND VA.AJUPRV < 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15415 - P13-PROVISAO ACUM MA 13 SAL TOTAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: basprv
Migrar quando a coluna "tipprv" for igual a 2 e a coluna "tipval" for igual a 1
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   33 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15415 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.BASPRV AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 2
   AND VA.TIPVAL = 1
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15420 - P13-PROVISAO ACUM MA INSS 13 SAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: basprv
Migrar quando a coluna "tipprv" for igual a 2 e a coluna "tipval" for igual a 2
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   33 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15420 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.BASPRV AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 2
   AND VA.TIPVAL = 2
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15425 - P13-PROVISAO ACUM MA FGTS 13 SAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: basprv
Migrar quando a coluna "tipprv" for igual a 2 e a coluna "tipval" for igual a 3
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   33 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15425 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.BASPRV AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 2
   AND VA.TIPVAL = 3
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15310 - P13-PROVISAO MES 13 SAL TOTAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: prvmes
Migrar quando a coluna "tipprv" for igual a 2 e a coluna "tipval" for igual a 1 e o valor for positivo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   33 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15310 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.PRVMES AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 2
   AND VA.TIPVAL = 1
   AND VA.PRVMES > 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15315 - P13-PROVISAO MES INSS 13 SAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: prvmes
Migrar quando a coluna "tipprv" for igual a 2 e a coluna "tipval" for igual a 2 e o valor for positivo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   33 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15315 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.PRVMES AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 2
   AND VA.TIPVAL = 2
   AND VA.PRVMES > 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15320 - P13-PROVISAO MES FGTS 13 SAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: prvmes
Migrar quando a coluna "tipprv" for igual a 2 e a coluna "tipval" for igual a 3 e o valor for positivo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   33 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15320 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.PRVMES AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 2
   AND VA.TIPVAL = 3
   AND VA.PRVMES > 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15345 - P13-BAIXA MES 13 SAL TOTAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: prvmes
Migrar quando a coluna "tipprv" for igual a 2 e a coluna "tipval" for igual a 1 e o valor for negativo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   33 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15345 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.PRVMES * (-1) AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 2
   AND VA.TIPVAL = 1
   AND VA.PRVMES < 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15350 - P13-BAIXA MES INSS 13 SAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: prvmes
Migrar quando a coluna "tipprv" for igual a 2 e a coluna "tipval" for igual a 2 e o valor for negativo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   33 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15350 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.PRVMES * (-1) AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 2
   AND VA.TIPVAL = 2
   AND VA.PRVMES < 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15355 - P13-BAIXA MES FGTS 13 SAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: prvmes
Migrar quando a coluna "tipprv" for igual a 2 e a coluna "tipval" for igual a 1 e o valor for negativo.
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   33 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15355 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.PRVMES * (-1) AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 2
   AND VA.TIPVAL = 1
   AND VA.PRVMES < 0.00
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15380 - P13-PROVISAO ACUM 13 SAL TOTAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: sldatu
Migrar quando a coluna "tipprv" for igual a 2 e a coluna "tipval" for igual a 1
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   33 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15380 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.SLDATU AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 2
   AND VA.TIPVAL = 1
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15385 - P13-PROVISAO ACUM INSS 13 SAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: sldatu
Migrar quando a coluna "tipprv" for igual a 2 e a coluna "tipval" for igual a 2
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   33 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15385 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.SLDATU AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 2
   AND VA.TIPVAL = 2
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 15390 - P13-PROVISAO ACUM FGTS 13 SAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R146PRV Coluna: sldatu
Migrar quando a coluna "tipprv" for igual a 2 e a coluna "tipval" for igual a 3
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.TIPPRV, VA.TIPVAL, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.MESANO,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.MESANO,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   33 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   15390 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.SLDATU AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R146PRV VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPPRV = 2
   AND VA.TIPVAL = 3
--===================================================================================================================================================================================



--===================================================================================================================================================================================
--> GERANDO ARQUIVO PARA IMPORTAO A PARTIR DA VIEW
--===================================================================================================================================================================================
SELECT '1' AS "01 Quando o registro existir",
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CASE WHEN VA.NUMEMP = 1 THEN 304
		    WHEN VA.NUMEMP = 2 THEN 303
		    ELSE 0
	   END					AS [02 Cdigo da Empresa],
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       DBO.FNC_DEPARA(CAST(VA.NUMEMP AS VARCHAR)+'_'+CAST(VA.TIPCOL AS VARCHAR)+'_'+CAST(VA.NUMCAD AS VARCHAR),'MATRICULA','HMC-IMC-SJRP') AS [03 Matrcula do colaborador],
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       VA.COD_FOLHA_LG AS [04 Cdigo da folha],
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       VA.REFER AS [05 Ms de Referncia],
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       VA.COD_EVENTO_LG AS [06 Cdigo do Evento],
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       '' AS [07 Total das parcelas],
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       '' AS [08 N da parcela atual],
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       VA.VALOR AS [09 Valor Evento]
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM VW_FICHA_FINANCEIRA_SENIOR_PROVISAO VA
 WHERE VA.NUMEMP IN (1,2)
   AND VA.COD_FOLHA_LG = 32 AND VA.COD_EVENTO_LG = 15010
 ORDER BY REFER_NUM DESC, VA.NUMEMP, VA.NUMCAD, VA.TIPCOL, VA.COD_FOLHA_LG, VA.COD_EVENTO_LG


/**********/
/*** OU ***/
/**********/

/*
SELECT *
  INTO TB_AUX_FICHA_FINANCEIRA_SENIOR_PROVISAO
  FROM VW_FICHA_FINANCEIRA_SENIOR_PROVISAO VA
 WHERE VA.NUMEMP IN (1,2)
   AND VA.COD_FOLHA_LG = 32 AND VA.COD_EVENTO_LG = 15010
*/

--======================================================================================================================
--> GERANDO TABELA AUXILIAR E DEPOIS O ARQUIVO A PARTIR DA TABELA (EXECUTAR QUANDO PERFORMANCE VIEW FOR LENTA)
--======================================================================================================================
-- DROP TABLE [TB_AUX_FICHA_FINANCEIRA_SENIOR_PROVISAO]
-- TRUNCATE TABLE [TB_AUX_FICHA_FINANCEIRA_SENIOR_PROVISAO]
CREATE TABLE [dbo].[TB_AUX_FICHA_FINANCEIRA_SENIOR_PROVISAO](
	[NUMEMP] [smallint]     NOT NULL,
	[TIPCOL] [smallint]     NOT NULL,
	[NUMCAD] [int]          NOT NULL,
	[TIPPRV] [smallint]     NOT NULL,
	[TIPVAL] [smallint]     NOT NULL,
	[REFER_NUM] [bigint]    NOT NULL,
	[REFER] [varchar](50)   NOT NULL,
	[COD_FOLHA_LG] [int]    NOT NULL,
	[COD_EVENTO_LG] [int]   NOT NULL,
	[VALOR] [numeric](18,2) NOT NULL
) ON [PRIMARY]
GO

CREATE INDEX IDX_TA_FF_PRV_001 ON [TB_AUX_FICHA_FINANCEIRA_SENIOR_PROVISAO] (REFER_NUM, NUMEMP, NUMCAD, TIPCOL, [COD_FOLHA_LG], [COD_EVENTO_LG])
CREATE INDEX IDX_TA_FF_PRV_002 ON [TB_AUX_FICHA_FINANCEIRA_SENIOR_PROVISAO] (REFER_NUM, [COD_FOLHA_LG], [COD_EVENTO_LG])
CREATE INDEX IDX_TA_FF_PRV_003 ON [TB_AUX_FICHA_FINANCEIRA_SENIOR_PROVISAO] ([COD_FOLHA_LG], [COD_EVENTO_LG])


/*
DELETE
  FROM [TB_AUX_FICHA_FINANCEIRA_SENIOR_PROVISAO]
 WHERE COD_FOLHA_LG = 32 
   AND COD_EVENTO_LG = 15010
*/

INSERT INTO [TB_AUX_FICHA_FINANCEIRA_SENIOR_PROVISAO]
SELECT VA.NUMEMP,
       VA.TIPCOL,
       VA.NUMCAD,
       VA.TIPPRV,
       VA.TIPVAL,
       VA.REFER_NUM,
       VA.REFER,
       VA.COD_FOLHA_LG,
       VA.COD_EVENTO_LG,
       VA.VALOR
  FROM VW_FICHA_FINANCEIRA_SENIOR_PROVISAO VA
 WHERE VA.NUMEMP IN (1,2)
   --AND VA.COD_FOLHA_LG = 32 AND VA.COD_EVENTO_LG = 15010



SELECT '2' AS "01 Quando o registro existir",
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CASE WHEN VA.NUMEMP = 1 THEN 304
		    WHEN VA.NUMEMP = 2 THEN 303
		    ELSE 0
	   END					AS [02 Cdigo da Empresa],
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       DBO.FNC_DEPARA(CAST(VA.NUMEMP AS VARCHAR)+'_'+CAST(VA.TIPCOL AS VARCHAR)+'_'+CAST(VA.NUMCAD AS VARCHAR),'MATRICULA','HMC-IMC-SJRP') AS [03 Matrcula do colaborador],
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       VA.COD_FOLHA_LG AS [04 Cdigo da folha],
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       VA.REFER AS [05 Ms de Referncia],
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       VA.COD_EVENTO_LG AS [06 Cdigo do Evento],
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       '' AS [07 Total das parcelas],
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       '' AS [08 N da parcela atual],
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       SUM(VA.[VALOR]) AS [09 Valor Evento]
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM [TB_AUX_FICHA_FINANCEIRA_SENIOR_PROVISAO] VA
 WHERE VA.REFER_NUM BETWEEN 202001 AND 202012
 GROUP BY VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.COD_FOLHA_LG, VA.REFER, VA.REFER_NUM, VA.COD_EVENTO_LG
HAVING SUM(VA.[VALOR]) > 0
 ORDER BY REFER_NUM DESC, VA.NUMEMP, VA.NUMCAD, VA.TIPCOL, VA.COD_FOLHA_LG, VA.COD_EVENTO_LG


