/**********************************************************************************************************************/
/********** PROJETO GHC - BASE SENIOR - SJRP - 2022 *******************************************************************/
/********** MIGRAO DE FICHA FINANCEIRA ******************************************************************************/
/**********************************************************************************************************************/
/* SCRIPT 05 - MIGRAO DA FICHA FINANCEIRA DOS AUTONOMOS                                                             */
/**********************************************************************************************************************/
/* SOMENTE NUMEMP 1 E 2                                                                                              */
/**********************************************************************************************************************/



ALTER VIEW VW_FICHA_FINANCEIRA_SENIOR_AUTONOMOS AS
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 6400 - VL SERVICOS PRESTADOS
------------------------------------------------------------------------------------------------------------------------
Tabela: R032TPG Coluna: RENBRU
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.cmppte,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.cmppte,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   21 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   6400 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.renbru AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R032TPG VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
 WHERE VA.TIPCOL = 2
   AND VA.renbru > 0
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 12145 - BASE INSS AUTONOMO
------------------------------------------------------------------------------------------------------------------------
Tabela: R032TPG Coluna: RENBRU
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.cmppte,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.cmppte,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   21 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   12145 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.renbru AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R032TPG VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPCOL = 2
   AND VA.renbru > 0
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 13350 - BASE LIQUIDA IRRF AUTONOMOS
------------------------------------------------------------------------------------------------------------------------
Tabela: R032TPG Coluna: RENBRU E DEDINS
Regra: Subtrao (RENBRU - DEDINS)
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.cmppte,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.cmppte,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   21 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   13350 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.renbru - VA.DEDINS AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R032TPG VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPCOL = 2
   AND VA.renbru > 0
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 7240 - INSS CONTRIBUINTE INDIVIDUAL
------------------------------------------------------------------------------------------------------------------------
Tabela: R032TPG Coluna: DEDINS
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.cmppte,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.cmppte,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   21 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   7240 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.DEDINS AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R032TPG VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPCOL = 2
   AND VA.DEDINS > 0
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 7600 - PENSAO ALIMENTICIA MES
------------------------------------------------------------------------------------------------------------------------
Tabela: R032TPG Coluna: PENJUD
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.cmppte,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.cmppte,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   21 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   7600 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.PENJUD AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R032TPG VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPCOL = 2
   AND VA.PENJUD > 0
------------------------------------------------------------------------------------------------------------------------
UNION ALL
------------------------------------------------------------------------------------------------------------------------
/*
------------------------------------------------------------------------------------------------------------------------
EVENTO 7455 - IRRF AUTONOMOS
------------------------------------------------------------------------------------------------------------------------
Tabela: R032TPG Coluna: IRFRET
------------------------------------------------------------------------------------------------------------------------
*/
SELECT VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, 
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CONVERT(BIGINT,LEFT(CONVERT(VARCHAR,VA.cmppte,112),6)) AS REFER_NUM, REPLACE(RIGHT(CONVERT(VARCHAR,VA.cmppte,103),7),'/','') AS REFER,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   21 AS COD_FOLHA_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   7455 AS COD_EVENTO_LG,
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	   VA.IRFRET AS VALOR
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM R032TPG VA --> TABELA SENIOR DE HISTORICO DE EVENTOS CALCULADOS DE FERIAS
       INNER JOIN R034FUN FUN --> TABELA SENIOR DE FUNCIONARIOS
	   ON (VA.NUMEMP = FUN.NUMEMP AND VA.TIPCOL = FUN.TIPCOL AND VA.NUMCAD = FUN.NUMCAD)
	   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG  --> TABELA AUXILIAR SOMENTE COM OS FUNCIONARIOS MIGRADOS NO ESCOPO
	   ON (FUN.NUMEMP = MIG.NUMEMP AND FUN.TIPCOL = MIG.TIPCOL AND FUN.NUMCAD = MIG.NUMCAD)
 WHERE VA.TIPCOL = 2
   AND VA.IRFRET > 0;





--===================================================================================================================================================================================
--> GERANDO ARQUIVO PARA IMPORTAO A PARTIR DA VIEW
--===================================================================================================================================================================================
SELECT '1' AS "01 Quando o registro existir",
       ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       CASE WHEN VA.NUMEMP = 1 THEN 304
		    WHEN VA.NUMEMP = 2 THEN 303
		    ELSE 0
	   END					AS [02 Cdigo da Empresa],
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       DBO.FNC_DEPARA(CAST(VA.NUMEMP AS VARCHAR)+'_'+CAST(VA.TIPCOL AS VARCHAR)+'_'+CAST(VA.NUMCAD AS VARCHAR),'MATRICULA','HMC-IMC-SJRP') AS [03 Matrcula do colaborador],
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       VA.COD_FOLHA_LG AS [04 Cdigo da folha],
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       VA.REFER AS [05 Ms de Referncia],
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       VA.COD_EVENTO_LG AS [06 Cdigo do Evento],
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       '' AS [07 Total das parcelas],
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       '' AS [08 N da parcela atual],
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
       SUM(VA.VALOR) AS [09 Valor Evento]
	   ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  FROM VW_FICHA_FINANCEIRA_SENIOR_AUTONOMOS VA
 WHERE VA.NUMEMP IN (1,2)
   AND VA.REFER_NUM BETWEEN 190001 AND 201912
   --AND VA.COD_FOLHA_LG = 32 AND VA.COD_EVENTO_LG = 15010
 GROUP BY VA.NUMEMP, VA.TIPCOL, VA.NUMCAD, VA.COD_FOLHA_LG, VA.REFER, VA.REFER_NUM, VA.COD_EVENTO_LG
HAVING SUM(VA.VALOR) > 0
 ORDER BY REFER_NUM DESC, VA.NUMEMP, VA.NUMCAD, VA.TIPCOL, VA.COD_FOLHA_LG, VA.COD_EVENTO_LG;