/* Trigger: INSERE_ORGANIZACAO_OPERADOR
   Tabela : OPERADOR

   Criao:
   10/02/2014 - Marcelo Alexsandro Souza Silva
*/

CREATE OR REPLACE TRIGGER INSERE_ORGANIZACAO_OPERADOR
AFTER INSERT
ON OPERADOR FOR EACH ROW
DECLARE
   V_COUNT             INTEGER;
   V_NOVOCODIGO        VARCHAR2(20);
   V_NRORGANIZACAOOPER NUMBER;
BEGIN
   V_COUNT := 0;
   SELECT COUNT(1)
     INTO V_COUNT
     FROM ORGANIZACAO;

   IF V_COUNT < 2 THEN
      NOVO_CODIGO_SC('ORGANIZACAOOPER', V_NOVOCODIGO);
      V_NRORGANIZACAOOPER := TO_NUMBER(V_NOVOCODIGO);

      INSERT INTO ORGANIZACAOOPER (NRORGANIZACAOOPER, NRORGREL, CDOPERADOR, DTINCLUSAO)
      SELECT V_NRORGANIZACAOOPER, :NEW.NRORG, :NEW.CDOPERADOR, SYSDATE
        FROM DUAL
       WHERE NOT EXISTS (SELECT 1
                           FROM ORGANIZACAOOPER O
                          WHERE O.CDOPERADOR = :NEW.CDOPERADOR
                            AND O.NRORGREL   = :NEW.NRORG);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('INSERE_ORGANIZACAO_OPERADOR','5.70.000'); END;
/
